package org.ilrt.inkling.api;
import java.util.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
<pre>
An object to encompass a squish query - basically a Graph with some
useful extra bits.

You should not have to deal with it directly: for squish queries use

        Graph gr = new Graph(null, uri, Util.RDFXML);
        gr.load();
        UnionGraph ug=new UnionGraph();
        ug.add(gr);

        java.sql.ResultSet r=ug.askSquish(query);

or for squish queries with 'from' clauses specifying the urls to query, use
    
        Graph gr = new Graph();
	java.sql.ResultSet r=gr.askSquish(query);


and for SQLGraph queries use this:

        SQLGraph sq = new SQLGraph();
	sq.setdb("jdbc:mysql://127.0.0.1:3306/codepict3?user=mysql&useUnicode=true");
        sq.setDriver("com.mysql.jdbc.Driver");
        Graph gr = new Graph(null, uri, Util.RDFXML);
        gr.load();
        sq.add(gr);

	java.sql.ResultSet r=sq.askSquish(query);

although you can use ComplexQuery directly:

        ComplexQuery cq=(ComplexQuery)SquishParser.parse(query);
        cq.getGraphs().addElement(ug);
        QE qe=new QE();
                
        java.sql.ResultSet r=qe.executeQuery(cq);

</pre>
*/


public class ComplexQuery extends Graph implements GraphInterface{

//complete list of variables in the query
Vector variables = new Vector();

//the selected ones
Vector variablesWeWant = new Vector();

//the sources
Vector graphs = new Vector();

//constraints
Vector constraints = new Vector();

//the using parts of the squish query
Hashtable namespaces = new Hashtable();

/**

A Vector of Graphs used in the Query

*/

public Vector getGraphs(){
return graphs;
}

/**

returns the variables specified in the SELECT clause

*/

public Vector getVariablesWeWant(){

	if(variablesWeWant.size()==0){
//System.err.println("CQ problem: no variables we want");
//return variables;
	}
//defaults to all
return variablesWeWant;

}


/**

All the variables used in the query. Use getVariablesWeWant for the 
variables in the SELECT clause.

*/

public Vector getVariables(){
return variables;
}


/**

Sets the full variables list

*/

private void setVariables(Vector v){
variables=v;
}


/**

Sets the variables in the select clause

*/

public void setVariablesWeWant(Vector v){
variablesWeWant=v;
}


/**

A Vector of constraints in Statement form

*/

public Vector getConstraints(){
return constraints;
}


/*
public Hashtable getNamespaces(){
return namespaces;
}

*/

/**

Returns a list of the triples part of the query - the WHERE clauses, as 
Querys

*/

public Vector getTriples(){
return getStatements();
}

/**

Sets the list of the triples part of the query - the WHERE clauses, as
Querys

*/

private void setTriples(Vector v){
tellAll(v);
}


}
