package org.ilrt.inkling.api;

import java.util.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
<pre>
Inspired by http://www.w3.org/2001/12/rubyrdf/basicrdf.rb

An interface for Graph objects
</pre>
*/

public interface GraphInterface {


/**

Returns a Vector of all Statements in the GraphInterface

*/
    public Vector getStatements();

/**

Inserts all the Statements into a Vector into the GraphInterface

*/

    public void tellAll(Vector statements);


/**

Insert a single Statement into the GraphInterface

*/
    public void tell(Statement statement);


/**

Return a Graph matching the query triple specified. The Query can have 
null arguments.

*/

    public Graph ask(Query query);

/**

Return a Graph matching the query triple specified. Arguments should be 
Strings, Nodes or null.

*/

    public Vector ask(Object s, Object p, Object o);


/**

Sets the base uri for the GraphInterface. Usually this will be the url 
or filename of an RDF file. For UnionGraphs it is @@fixme@@; for SQLGraph 
it is the jdbc database url.

*/

    public String getBase();


/**

Returns the base uri for the GraphInterface. Usually this will be the url 
or filename of an RDF file. For UnionGraphs it is @@fixme@@; for SQLGraph 
it is the jdbc database url.

*/

    public void setBase(String base);

/**

Ask a squish query of any type of Graph returnign a rectangular ResultSet.

*/

    public java.sql.ResultSet askSquish(String query);

/**

Delete a single statement (or all instances of a given Statement).

*/

    public boolean delete(Statement s);

/**

Remove all statements.

*/

    public boolean removeAll();

}//end class


