package org.ilrt.inkling.api;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
<pre>
A tiny interface for loading various graph formats. See Util and
external/, and an example in Graph.

LoaderInterface loader=(LoaderInterface)Class.forName(handler).newInstance();
gets a new instance of LoaderInterface such as 
org.ilrt.inkling.external.RioWrapper and 
org.ilrt.inkling.external.ARPWrapper to handle the parsing of RDF 
documents in various formats.

Various mappings from short names to class names are in api.Util.
</pre>
*/


public interface LoaderInterface{

/**

loads the file or url to a Graph and returns it

*/

public GraphInterface loadGraph(String file);

/**

loads the file or url to the specified GraphInterface and returns it

*/

public GraphInterface loadGraph(String file, GraphInterface graph);

}
