package org.ilrt.inkling.api;


import java.util.*;
import java.sql.*;
import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
<pre>
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231

A Graph for SQL Databases.
To add data to an SQLGraph, create a Graph and then add() to SQLGraph.
Use setdb() and setDriver() to specify the database.
See test/SQLGraphTest.java for usage.

        
String
db="jdbc:mysql://127.0.0.1:3306/codepict3?user=mysql";
        
int count=0;

        SQLGraph sq = new SQLGraph();
        sq.setdb(db);
        sq.setDriver("com.mysql.jdbc.Driver");
        Graph gr = new Graph(null, uri, Util.RDFXML);
        gr.load();
        sq.add(gr);

        java.sql.ResultSet r=sq.askSquish(query);
</pre>
*/

public class SQLGraph implements GraphInterface{

public static void main(String args[]){

String
file="http://swordfish.rdfweb.org/photos/genfiles/ilrt/17299382716049383.rdf";

Graph gr = new Graph(null, file, Util.RDFXML);
gr.load();

SQLGraph sq = new SQLGraph();
sq.add(gr);

}

    String table="triples";
    static Graph defaultdb = null;
    static String driver="org.postgresql.Driver";
    String
dburi="jdbc:postgresql://localhost:5432/test?auth=password&user=postgres&password=notneeded";
    String id = "";
    Hashtable graphs = new Hashtable();

/**

Set the database uri, for example
setdb("jdbc:postgresql://localhost:5432/test?auth=password&user=postgres&password=notneeded")

*/

	public void setdb(String dburi){
	this.dburi=dburi;
	}


/**

set the database driver, e.g.
setDriver("org.postgresql.Driver")

*/
	public void setDriver(String driver){
	this.driver=driver;
	}

/**

Return the database url 

*/
	public String getdb(){
	return dburi;
	}


/**

Return the database driver

*/
	public String getDriver(){
	return driver;
	}


/** 

Loads in a Graph, removing existing data from that Graph first. Graph
should be previously populated using load()

*/


    public void add(Graph g){

	graphs.put(g.getBase(),g);

	String cmd="delete from triples where source='"+g.getBase()+"';";
//	String cmd2="delete from resources where source='"+g.getBase()+"';";

	try{
	makeJDBCCommand(cmd);
//	makeJDBCCommand(cmd2);
	}catch(Exception re){
	System.err.println(re);
	}
///for each statement, add into correct tables etc
	tellAll(g.getStatements(),g.getBase());


/**

Removes the triples with a particular base (usually from a specific
url)

*/

    }

    public void remove(String base){

	graphs.remove(base);

	String cmd="delete from triples where source='"+base+"';";

	try{
	makeJDBCCommand(cmd);
	}catch(Exception re){
	System.err.println(re);
	}

    }

/**

Tell all the Statements in a Vector to the SQLGraph. It's better to 
create a Graph object and use add() than using this method.

*/

    public void tellAll(Vector states) {

	tellAll(states,null);

    }


/**

Tell all the Statements in a Vector to the SQLGraph. It's better to 
create a Graph object and use add() than using this method.

*/
    public void tellAll(Vector states, String graphid) {

        for (Iterator iterator = states.listIterator();
                iterator.hasNext();) {
            Statement statement = (Statement) iterator.next();
            //System.out.println("**telling "+statement);
		if(graphid==null){
		graphid=getBase();
		}

            tell(statement,graphid);
        }

    }

/**

Insert a statement into the database, using the ID of the database as the 
source id. 

*/

    public void tell(Statement statement) {

	tell(statement,null);

    }



/**

Insert a statement into the database. id is usually the data source or
url.
Note that literals are stored with a " in front of them. This is to
speed identification of literals. blank nodes start with _:

As a hardcoded feature, all foaf:mboxes are converted to
foaf:mbox_sha1sum as an extra triple.

*/

    public void tell(Statement statement, String id) {

	if(id==null){
	id=getBase();
	}

	String locutor=id;

	Vector queries = new Vector();

            String assertId1 = Util.getRandomString();

	    String subject=statement.getSubject().getContent();
	    String object=statement.getObject().getContent();
	    String predicate=statement.getPredicate().getContent();


            ///sha1 stuff
            int sh1subject = 0;
            int sh1predicate = 0;
            int sh1object = 0;
            int sh1sh1ob = 0;
            int type = 0;

                if (statement.getObject().isresource) {
                    type = 0;
                } else {
                    type = 1;

		    object="\""+object;
                }


//for foaf applications
	    String mbsha1pred="http://xmlns.com/foaf/0.1/mbox_sha1sum";

	    int sha1mbsha1pred=0;

//note the additional "
	    String sh1ob="\""+Util.sha1(object);//!! for now

            try {

                sh1subject = Util.hashcodeIntFromString(subject);
                sh1predicate = Util.hashcodeIntFromString(predicate);
                sh1object = Util.hashcodeIntFromString(object);
        	sha1mbsha1pred =
Util.hashcodeIntFromString(mbsha1pred);
		sh1sh1ob= Util.hashcodeIntFromString(sh1ob);


            } catch (Exception es) {
                System.out.println("could not compute digest "+es);
            }


//foaf extra stuff

	String mbpred="http://xmlns.com/foaf/0.1/mbox";

            String assertId11 = Util.getRandomString();


	if(predicate.equals(mbpred)){

            queries.addElement("insert into "+table + " values ('"+
                    sh1subject + "','"+sha1mbsha1pred + "','"+
                    sh1sh1ob + "','"+locutor+"','1');");

//conversion of mbox to mbox_sha1sum
/*
            queries.addElement("insert into resources values ('"+
                    sha1mbsha1pred + "','"+mbsha1pred +"','"+locutor+"');");
*/
            queries.addElement("insert into resources values ('"+
                    sha1mbsha1pred + "','"+mbsha1pred +"');");

            queries.addElement("insert into resources values ('"+
                    sh1sh1ob + "','"+sh1ob + "');");
/*
            queries.addElement("insert into resources values ('"+
                    sh1sh1ob + "','"+sh1ob + "','"+locutor+"');");
*/
	 }

//end foaf extra stuff

            queries.addElement("insert into "+table + " values ('"+
                    sh1subject + "','"+sh1predicate + "','"+
                    sh1object + "','"+locutor + "','"+
                    type + "');");

            queries.addElement("insert into resources values ('"+
                    sh1subject + "','"+subject + "');");
            queries.addElement("insert into resources values ('"+
                    sh1predicate + "','"+predicate +"');");

/*
            queries.addElement("insert into resources values ('"+
                    sh1subject + "','"+subject + "','"+locutor+"');");
            queries.addElement("insert into resources values ('"+
                    sh1predicate + "','"+predicate +"','"+locutor+"');");
*/

//fix apostrophe, comma - needs diferent fix for postgres?
//testing

	if(getdb().startsWith("jdbc:mysql")){
	object=Util.replace(object,"'","''");
	}else{
	object=Util.replace(object,"'","''");//postgres
	}

/*
            queries.addElement("insert into resources values ('"+
                    sh1object + "','"+object + "','"+locutor+"');");
*/
            queries.addElement("insert into resources values ('"+
                    sh1object + "','"+object + "');");


        Enumeration en = queries.elements();
        while (en.hasMoreElements()) {
            try {
                String qq = en.nextElement().toString();

                makeJDBCCommand(qq);

            } catch (Exception e) {
                System.err.println("SQLG: assertion failed" + e);
            }
        }

   }

    /** 
Makes a command to a jdbc db - i.e. inserts, deletes 

*/

    public void makeJDBCCommand(String command) throws SQLException {

//System.out.println("driver "+driver+" command "+command);

            try {
                Class.forName(getDriver());
            } catch (Exception eee) {
                System.err.println("SQLMC: error loading driver " + eee);
		//eee.printStackTrace();
            }
            java.sql.Connection conn = null;
            try {
                conn = java.sql.DriverManager.getConnection(getdb());
                java.sql.Statement s = conn.createStatement();
                s.executeUpdate(command);
                conn.close();
            } catch (Exception eeee) {
//                System.err.println( "SQLG:[3] " + eeee + " "+command);

//		eeee.printStackTrace();
                if (conn != null) {
                    conn.close();
                }
            }
    } //end command method




/**
Performs an SQL query, converting the result to a
org.ilrt.inkling.query.ResultSet, so that provenance and literal, bnode
etc can be identified through the extended API.
In this case it also sets whether SQL database returns provenance or
not. If true, may be slower, and contain duplicates, so defaults to
false.

*/

public java.sql.ResultSet doSQLQuery(String sql_query,boolean prov){
org.ilrt.inkling.query.ResultSet rs =
(org.ilrt.inkling.query.ResultSet)doSQLQuery(sql_query);
rs.setSQLProv(prov);
return rs;

}

/**

Performs an SQL query, converting the result to a
org.ilrt.inkling.query.ResultSet, so that provenance and literal, bnode
etc can be identified through the extended API.

*/

private java.sql.ResultSet doSQLQuery(String sql_query){

//System.out.println("QUERY "+sql_query);
//System.out.println("*** "+getDriver()+" "+getdb());
        java.sql.Connection myconn = null;
        java.sql.ResultSet results = null;
	java.sql.Driver mydriver=null;
        try {
            mydriver = (java.sql.Driver) Class.forName(
                    getDriver()).newInstance();
            myconn =
                    java.sql.DriverManager.getConnection(getdb());
            java.sql.Statement s = myconn.createStatement();
            results = s.executeQuery(sql_query);
            String colname;
            String value;
        int count=0;
        }
        catch (Exception e) {
            System.err.println("Error in database query operation " + e);
	//e.printStackTrace();
        }
        finally { try {
                myconn.close();
            } catch (Exception e) {}
        }

	java.sql.ResultSet rs = new org.ilrt.inkling.query.ResultSet();
	((org.ilrt.inkling.query.ResultSet)rs).setResultSet(results);
        return rs;
    }



/**

Performs a simple SQL query. Use this for straightfoward SQL queries.
Use doSQLQuery to squish queries only.

*/

public java.sql.ResultSet doSQLQueryClean(String sql_query){

        java.sql.Connection myconn = null;
        java.sql.ResultSet results = null;
	java.sql.Driver mydriver=null;
        try {
            mydriver = (java.sql.Driver) Class.forName(
                    getDriver()).newInstance();
            myconn =
                    java.sql.DriverManager.getConnection(getdb());
            java.sql.Statement s = myconn.createStatement();
            results = s.executeQuery(sql_query);
            String colname;
            String value;
        int count=0;
        }
        catch (Exception e) {
            System.err.println("Error in database query operation " + e);
	//e.printStackTrace();
        }
        finally { try {
                myconn.close();
            } catch (Exception e) {}
        }

        return results;
    }




/**

Ask a squish query of this database, returning a ResultSet.

*/


public java.sql.ResultSet askSquish(String query){
return askSquish(query,false);
}

/**

Ask a squish query of this database, returning a ResultSet.
Prov is whether you want the SQL database to return provenace
information or not. If so, this makes it slower and causes duplicates,
so defaults to false.

*/

public java.sql.ResultSet askSquish(String query,boolean prov){

        String sql_query = Squish2SQL.convert(query,prov);

System.out.println(sql_query);
return doSQLQuery(sql_query,prov);

}


/**

Ask a simple query of the database (via a generated squish query)

*/

    public Vector ask(Object ss, Object pp, Object oo){

        Node s=null;
        Node p=null;
        Node o=null;

                if (ss instanceof java.lang.String){
                s=new Node((String)ss);
                }else if(ss instanceof org.ilrt.inkling.api.Node || ss==null){
                s=(Node)ss;
                }
                else{
                System.err.println("Graph ask must be passed Strings or Nodes");
                return null;
                }   

                if (pp instanceof java.lang.String){
                p=new Node((String)pp);
                }else if(pp instanceof org.ilrt.inkling.api.Node || pp==null){
                p=(Node)pp;
                }
                else{
                System.err.println("Graph ask must be passed Strings or Nodes");
                return null;
                }   

                if (oo instanceof java.lang.String){
                o=new Node((String)oo);
                }else if(oo instanceof org.ilrt.inkling.api.Node || oo==null){
                o=(Node)oo;
                }
                else{
                System.err.println("Graph ask must be passed Strings or Nodes");
                return null;
                }   
                
	Graph g = this.ask(new Query(s,p,o));

	return g.getStatements();
    }

/**

Ask a simple query of the database (via a generated squish query)

*/

    public Graph ask(Query query) {

//use Query.toSquishString()

	Graph g=new Graph();
	Object s=query.getSubject();
	Object p=query.getPredicate();
	Object o=query.getObject();
	String sv=query.getSubjectVariable();
	String pv=query.getPredicateVariable();
	String ov=query.getObjectVariable();

	String qs;
	String qp;
	String qo;

	String squish_query="select ";
	
	if(s==null){
	qs="?s";
	squish_query=squish_query+qs;
		if(p==null || o==null){
		squish_query=squish_query+", ";
		}
	}else{
	qs=((Node)s).getContent();
	}
	if(p==null){
	qp="?p";
	squish_query=squish_query+qp;
		if(o==null){
		squish_query=squish_query+", ";
		}
	}else{
	qp=((Node)p).getContent();
	}
	if(o==null){
	qo="?o";
	squish_query=squish_query+qo+" ";
	}else{
	qo=((Node)o).getContent();
	}



	squish_query=squish_query+" where ("+qp+" "+qs+" "+qo+")";

	System.out.println("generated squish query "+squish_query);

//hm, rs to graph...?
//fixme: literals....

	try{

	java.sql.ResultSet rs=askSquish(squish_query);

	org.ilrt.inkling.query.ResultSet
rs2=(org.ilrt.inkling.query.ResultSet)rs;

		while(rs2.next()){
//		System.out.println("s "+(String)rs.getString("s"));
		String ss=(String)rs.getString("s");
		String pp=(String)rs.getString("p");
		String oo=(String)rs.getString("o");

		Statement st = new Statement(new Node(ss),new
Node(pp),new Node(oo));
		g.tell(st);
		}
	}catch(Exception z){
	System.out.println(z);
	}

	return g;

    }


/*

Get the number of triples in the database from a given source

*/

public int getSize(String id){
int si=0;
String cmd="select count(subject) from triples where source='"+id+"';";

java.sql.ResultSet r=null;
try{
r=doSQLQueryClean(cmd);

	if(r.next()){
	si=r.getInt("count(subject)");
	}

}catch(Exception re){
System.err.println(re);
}

return si;

}

/**

Get the size of the database

*/

public int getSize(){
int si=0;
String cmd="select count(subject) from triples;";

java.sql.ResultSet r=null;
try{
r=doSQLQueryClean(cmd);

//System.out.println("!!!"+r+" "+cmd);

if(r.next()){
si=r.getInt("count(subject)");
}

}catch(Exception re){
System.err.println(re);
}

return si;

}


/**

Get the size of the database

*/

public int size(){
return getSize();
}

/**

Get a list of all the Graphs in the database

*/

public Hashtable getGraphs(){
Hashtable graphs = new Hashtable();

String cmd="select distinct source from triples;";

java.sql.ResultSet r=null;
try{
r=doSQLQueryClean(cmd);

while(r.next()){
String s =(String)r.getString("source");
//note null
graphs.put(s,new Graph());
}

}catch(Exception re){
System.err.println(re);
re.printStackTrace();
}

return graphs;
}

/**

get all the Statements in the SQLGraph
@@testme

*/

public Vector getStatements(){

Graph g=this.ask(new Query(null,null,null));

return g.getStatements();

}


/**

The base url for an SQLGraph is the database url, e.g. 
jdbc:postgresql://localhost:5432/test?auth=password&user=postgres&password=notneeded

*/

public String getBase(){

return getdb();

}

/**

the base url for an SQLGraph is the database url, e.g. 
jdbc:postgresql://localhost:5432/test?auth=password&user=postgres&password=notneeded

*/

public void setBase(String base){

setdb(base);

}


/**

Delete a triple or triples from the database. Be warned that this 
operation will delete every occurrance of the triples from the database.
@@fixme - what if nulls?

*/

public boolean delete(Statement statement){

boolean b = true;

String s=statement.getSubject().getContent();
String p=statement.getPredicate().getContent();
String o=statement.getObject().getContent();

String shas=Util.sha1(s);
String shap=Util.sha1(p);
String shao=Util.sha1(o);

	String cmd="delete from triples where subject='"+shas+"' and predicate='"+shap+"' and object='"+shao+"';";

	String cmd1="delete from resources where keyhash='"+shas+"';";
	String cmd2="delete from resources where keyhash='"+shap+"';";
	String cmd3="delete from resources where keyhash='"+shao+"';";

	try{
	makeJDBCCommand(cmd);
	makeJDBCCommand(cmd1);
	makeJDBCCommand(cmd2);
	makeJDBCCommand(cmd3);
	}catch(Exception re){
	System.err.println("SQLGraph: some or all of the triples was not deleted "+re);
	b=false;
	}

return b;
}


/**

Remove all the triples from the entire SQL database. Use with care.
Use public void remove(String base) to remove only those triples form a 
particular base url.

*/

public boolean removeAll(){
boolean b =true;

	String cmd1="delete from triples;";
	String cmd2="delete from resources;";

	try{
	makeJDBCCommand(cmd1);
	makeJDBCCommand(cmd2);
	}catch(Exception re){
	System.err.println("SQLGraph: some or all of the triples was not deleted "+re);
	b=false;
	}

return b;
}

}//end class


