package org.ilrt.inkling.api;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
<pre>
Extension of Node required to convert quirks of SQL layout to useful
objects, for example _: indicating a bnode and " indicating a literal

        SQLGraph sq = new SQLGraph();
        sq.setdb(db);
        sq.setDriver("com.mysql.jdbc.Driver");
        Graph gr = new Graph(null, uri, Util.RDFXML);
        gr.load();
        sq.add(gr);

	java.sql.ResultSet r1=sq.askSquish(query);
org.ilrt.inkling.query.ResultSet r2=(org.ilrt.inkling.query.ResultSet)r1;

	SQLNode mbsh1=(Node)r2.getSQLNode("mbsh1");
	
This will return an SQLNode with bnode and literal/resource information, 
and provenance if source is switched on @@checkme
</pre>
*/


public class SQLNode extends Node{
public SQLNode(){
super();
}

/**

create an SQL node, deriving its type from the String

*/

public SQLNode(String content){

//fix literal
	if(content.startsWith("\"")){
	setContent(content.substring(1));
	isresource=false;
	isbnode=false;
	}else if(content.startsWith("_:")){
	isresource=true; isbnode=true;
	setContent(content);
	}else{
	isresource=true; isbnode=false;
	setContent(content);
	}
}


/**

access method, stripping the " from the data

*/

public String getContent(){

String s = super.getContent();
	if(s!=null && s.startsWith("\"")){
	s=s.substring(1);
	}

return s;
}


/**

Access method

*/

public String toString(){
return getContent();
}

}
