package org.ilrt.inkling.api;

import java.util.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
<pre>
An aggregate inmemory Graph, acting much like an SQLGraph.
This keeps a reference to each Graph added but also a central triple
store containing all the triples from all Graphs.

Use add(), remove()

For example (from UnionGraphAddRemoveTest):

Graph g = new
Graph(null,
"http://swordfish.rdfweb.org/people/libby/rdfweb/webwho.xrdf",Util.RDFXML);

g.load();

UnionGraph ug=new UnionGraph();
ug.add(g);

assertEquals(g.size(),ug.size());

ug.remove(g);
</pre>
*/


public class UnionGraph extends Graph implements GraphInterface{

Hashtable graphs = new Hashtable();

/**

Get the list of Graphs held in the UnionGraph

*/

public Hashtable getGraphs(){
return graphs;
}

/**

Add a Graph to the UnionGraph

*/

public void add(Graph graph){
 graphs.put(graph.getID(),graph);
 ((Graph)this).tellAll(graph.getStatements());
}


/**

Removes all the triples and the ID

*/

public void remove(Graph graph){
 graphs.remove(graph.getID());
 Vector v=graph.getStatements();
 Enumeration e=v.elements();
	while(e.hasMoreElements()){
	this.delete((Statement)e.nextElement());
	} 

}


}
