package org.ilrt.inkling.api;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
<pre>
Useful things:

* short names mapped to handlers for LoaderInterface useage
* numeric sha1 (int) generation from a String
* String sha1 generation from a String
* random String generation
* saving files
* reading files to Strings
* spliting a String into a Vector by a character
* replacing one String by another in a third String
</pre>
*/


import java.security.MessageDigest;
import java.math.BigInteger;
import java.io.*;
import java.util.*;
import java.net.*;


public class Util {

public static void main(String args[]){
String url="file:scutterplan.rdf";
System.out.println(readFile(url));

}


/*

Useful names for types of RDF content

*/

/*
public final static String 
NTRIPLES="http://www.w3.org/2003/03/rdfqr-tests/query.rdfs#NT-Document";
public final static String 
SQUISH="http://www.w3.org/2003/03/rdfqr-tests/query.rdfs#Squish-Document";
public final static String 
RDFXML="http://www.w3.org/2003/03/rdfqr-tests/query.rdfs#RDF-XML-Document";
public final static String 
TEST="http://www.w3.org/2003/03/rdfqr-tests/query.rdfs#RDF-XML-Document";
public final static String 
N3="http://www.w3.org/2003/03/rdfqr-tests/query.rdfs#N3-Document";
*/

public final static String 
NTRIPLES="NTRIPLES";
public final static String 
SQUISH="SQUISH";
public final static String
RDFXML="RDFXML";
public final static String
TEST="TEST";

public final static String DEFAULT=RDFXML;


public static Hashtable handlers=new Hashtable();

    static Random rand = new Random();

/**

Generates a numeric sha1

*/


    public static int hashcodeIntFromString(String digestme)
            throws java.security.NoSuchAlgorithmException {

        MessageDigest md = MessageDigest.getInstance("SHA");
        md.update(digestme.getBytes());
        byte[] digest = md.digest();
        return ((int) digest[0] & 0xff) | (((int) digest[1] & 0xff) << 8) |
                (((int) digest[2] & 0xff) << 16) |
                (((int) digest[3] & 0xff) << 24);

    }


/**

Generates a random String

*/

    public static String getRandomString() {
	String s=(new Long(Math.abs(rand.nextLong()))).toString();
        return s.substring(0,9);
    }


/**

Save a file given a filename and a String

*/

    public static void save(String filename, String filelocation, String content) {
        try {
            String s = filelocation + filename; 

  
	        if (s.startsWith("file:")) {
	            s = s.substring(5); 
	        }


            System.out.println("\n\nsaving to " + s);   
            FileWriter fwr = new FileWriter(s, false);
            fwr.write(content);
            fwr.close();
        } catch (Exception e) {
            System.out.println("Scutter: problem saving " + e);
        }
    }


/**

Read in a file form a String and return a String containing its contents

*/

   public static String readFile(String fn)  {
        if (fn.startsWith("file:")) {
            fn = fn.substring(5);
        }
        String text = "";
        //System.out.println("file: "+ fn);
        try{
        RandomAccessFile in = new RandomAccessFile(fn, "r");
        String line = "";
        while (line != null){
            if(!line.equals("")){
                 text += "\n"+line;
            }
        line = in.readLine();   
        }
        }catch(Exception e){
        System.err.println("NTParser error[3] "+e);
        }
	return text;
     }


/**

Get the class for handling a given type of RDF data given a String (e.g.
Util.RDFXML)

*/

	public static String getHandler(String type){
		handlers.put(NTRIPLES,"org.ilrt.inkling.api.NTReader");

		handlers.put(TEST,"org.ilrt.inkling.external.ARPWrapper");

		handlers.put(RDFXML,"org.ilrt.inkling.external.RioWrapper");
//bit experimental
		String handler=null;
		try{
			handler=(String)handlers.get(type);
		}catch(Exception e){
		System.err.println("no handler to get for "+type);
		}
		return handler;

	}


/**

Generates a Stringified sha1

*/

public static String sha1(String string){

     try
       {
        MessageDigest md = MessageDigest.getInstance("SHA");

        md.update(string.getBytes());
        byte[] digest = md.digest();

        BigInteger integer = new BigInteger(1, digest);
        return integer.toString(16);
       }
     catch (Exception e)
       {
        return null;
       }

}


/**

Splits a String into a Vector using instances of a character

*/

    public static Vector splitByString(String s, String ch) {
        Vector split = new Vector();
        StringTokenizer st = new StringTokenizer(s, ch);
        boolean doneFirst = false;
        while (st.hasMoreTokens()) {
            String sss = st.nextToken();
            //            System.out.println("next token is "+sss);
            split.addElement(sss.toString().trim());
            doneFirst = true;
        }
        return split;
    }


/**

Replace all instances of one one String in another with a third string

*/

    public static String replace(String s, String tofind,
            String toreplace) {
        StringBuffer result = new StringBuffer();
        boolean donef = false;

        if (s.indexOf(tofind) != -1) {
            while (s.indexOf(tofind) != -1) {
                int i = s.indexOf(tofind);
                result.append(getNextPart(s, i));
                donef = true;
                if (donef) {
                    result.append(toreplace);
                }
                s = s.substring(i + tofind.length());
                if (s.indexOf(tofind) == -1) {
                    result.append(toreplace + s);
                }

            }
        } else {
            result.append(s);  
        }
        return result.toString();
    }


/**
used by replace()
*/

    public static String getNextPart(String s, int i) {
        if (i != -1) {
            return s.substring(0, i);
        } else {
	System.out.println("NP: oops ");
            return s;
        }
    }




}
