package org.ilrt.inkling.app;

import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;
import org.ilrt.inkling.api.*;
import java.util.*;

/**

Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231

*/

/*
<pre>
Ask an in-memory query
</pre>
*/


public class Ask{


    public static void main(String args[]) {

        if(args.length>0){
        System.out.println(args[0]);
        (new Ask()).ask(args[0]);
        }else{
        System.out.println("usage: java org.ilrt.inkling.app.Ask "+
"filename\nwhere filename contains a squish query");
        }

    }

    public void ask(String filename){

String query=Util.readFile(filename);

String mbox="mailto:libby.miller@bristol.ac.uk";
String sha1mbox=Util.sha1(mbox);


if(query==null || query.equals("")){

String
uri="http://swordfish.rdfweb.org/photos/genfiles/ilrt/5018518518518519.rdf";
query= "SELECT ?pic, ?thumb, ?x  "+
" from "+uri+" "+
" WHERE "+
   "(foaf:depicts ?pic ?x) "+    
   "(foaf:mbox_sha1sum ?x ?mb) "+
   "(foaf:mbox_sha1sum ?x '"+sha1mbox+"') "+
   "(foaf:thumbnail ?pic ?thumb) "+
" USING foaf for http://xmlns.com/foaf/0.1/ "+
" dc for http://purl.org/dc/elements/1.1/ ";
}

java.sql.ResultSet r1 =null;

        Graph gr = new Graph();

        try{
        r1=gr.askSquish(query);


		Vector v=((org.ilrt.inkling.query.ResultSet)r1).getColumnNames();

		System.out.println(v);
                while (r1.next()) {

                Iterator i;

                        for (i = v.iterator(); i.hasNext();){
                        String variable_name = (String) i.next();
                        String value=r1.getString(variable_name);

//if you need to find out about bnode, literal, provenance etc, use this
//instead:

			Node node_value=((org.ilrt.inkling.query.ResultSet)r1).getNode(variable_name);  

                        System.out.println(variable_name+
                                ": "+value);
                        }

                }

        }catch(Exception e){
        System.err.println("Ask error "+e);
        e.printStackTrace();
        }

}

}
