package org.ilrt.inkling.app;

import java.sql.*;
import java.util.*;
import org.ilrt.inkling.api.*;
import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;

/**
<pre>
copyright Damian Steer -
http://rdfweb.org/people/damian/2002/02/foafnation/
</pre>
*/

public class BuildPaths
{

String driver="org.postgresql.Driver";
String pathdburi="jdbc:postgresql://localhost:5432/newpaths?auth=password&user=postgres&password=notneeded";

    public static void main(String args[])
    {



	int count=(new Integer(args[0])).intValue();
	BuildPaths bp = new BuildPaths();

	TGraph graph = new TGraph();

	bp.buildGraph(graph);
	
	System.out.println("# of nodes: " +graph.getNodes().size());
	System.out.println("# of edges: " + graph.getEdges().size());
	int noOfNodes = graph.getNodes().size();
	int nodeCount = 0;


	//delete the database
	String del="delete from data;";
	bp.insert(del);
	

	for (Enumeration e = graph.getNodes().elements(); e.hasMoreElements();)
	    {
		
		TNode tn = (TNode) e.nextElement();
		
		//Vector paths = tn.pathsFromWithTTL(count);

		Vector paths =  graph.findShortestPathsFromNode(tn);

		Vector toInsert= new Vector();

		/*
		 * Construct the strings for each path to insert into
		 * the database
		 */


		for (Iterator pathIterator = paths.iterator();
		     pathIterator.hasNext();)
		    {
			TElement leaf = (TElement) pathIterator.next();

			String path = "";
			String last =
leaf.node().getText().substring(1);
			String
lastName=leaf.node().getName().substring(1);

			while (leaf.parent() != null)
			    {
				// note: because we start at the bottom
				// we have to reverse the path
//dont know if we need parent name or leaf name
				path = "<" + leaf.edge().getLabel() +
				    ">"+"<" + leaf.node().getName() +">"
					 + path;
				leaf = leaf.parent();
			    }

			String first = leaf.node.getText().substring(1);
			String firstName=leaf.node.getName().substring(1);


			String query="insert into data values('"+
			first+"','"+last+"','"+firstName+"','"+lastName+"','"+path+"');";
			//System.out.println(query);

//			bp.insert(query);
//////for testing	
			toInsert.addElement(query);

		    }

		//System.out.println("toinsert "+toInsert);

		bp.insertBatch(toInsert);
		
		nodeCount++;
//debug		System.out.println("Completed node " + nodeCount +
//				   "/" + noOfNodes);
	    }
	
    }

    public void buildGraph(TGraph graph){
	
	SQLGraph sql= new SQLGraph();
	sql.setdb("jdbc:mysql://127.0.0.1:3306/codepict2?user=mysql");
	sql.setDriver("com.mysql.jdbc.Driver");

	//find the people linked to this mbox
	String query1="SELECT ?mbox1, ?mbox2, ?name1, ?name2, ?uri "+
	    "WHERE "+
	    "   (foaf::depiction ?x ?img) "+
	    "   (foaf::depiction ?z ?img) "+
	    "   (foaf::thumbnail ?img ?uri) "+
	    "   (foaf::mbox_sha1sum ?x ?mbox1) "+
	    "   (foaf::mbox_sha1sum ?z ?mbox2) "+
	    "   (foaf::name ?x ?name1) "+
	    "   (foaf::name ?z ?name2) "+
	    "USING foaf for http://xmlns.com/foaf/0.1/ "+
	    " rdf for http://www.w3.org/1999/02/22-rdf-syntax-ns#";
	
	System.out.println("1: "+query1+"\n\n");
	
	java.sql.ResultSet Recordset1 =null;
	java.sql.Driver DriverRecordset1=null;
	java.sql.Connection Conn1=null;
	
	try{
	Recordset1=sql.askSquish(query1);
	}catch(Exception e){
	    System.err.println("oops"+e);
	    e.printStackTrace();
	}
	
	try{
	    while (Recordset1.next()) {
		
		String mb1=(String)Recordset1.getString("mbox1");
		String mb2=(String)Recordset1.getString("mbox2");
		String uri=(String)Recordset1.getString("uri");
		String name1=(String)Recordset1.getString("name1");
		String name2=(String)Recordset1.getString("name2");

		graph.addPathWithName(mb1, mb2, uri, name1,name2);
	    }

	}catch(Exception e2){
	    System.err.println("oops"+e2);
	}

//second query

	//find the people linked to this mbox
	String query2="SELECT ?mbox1, ?mbox2, ?name1, ?name2, ?uri "+
	    "WHERE "+
	    "   (foaf::depicts ?img ?x) "+
	    "   (foaf::depicts ?img ?z) "+
	    "   (foaf::thumbnail ?img ?uri) "+
	    "   (foaf::mbox_sha1sum ?x ?mbox1) "+
	    "   (foaf::mbox_sha1sum ?z ?mbox2) "+
	    "   (foaf::name ?x ?name1) "+
	    "   (foaf::name ?z ?name2) "+
	    "USING foaf for http://xmlns.com/foaf/0.1/ rdf for "+
" http://www.w3.org/1999/02/22-rdf-syntax-ns#";
	
	System.out.println("2: "+query2+"\n\n");
	
	java.sql.ResultSet Recordset2 =null;
	java.sql.Driver DriverRecordset2=null;
	java.sql.Connection Conn2=null;
	
	try{
	    
	Recordset2=sql.askSquish(query2);

	}catch(Exception e){
	    System.err.println("oops"+e);
	    e.printStackTrace();
	}
	
	try{
	    while (Recordset2.next()) {
		
		String mb1=(String)Recordset2.getString("mbox1");
		String mb2=(String)Recordset2.getString("mbox2");
		String uri=(String)Recordset2.getString("uri");
		String name1=(String)Recordset2.getString("name1");
		String name2=(String)Recordset2.getString("name2");


		graph.addPathWithName(mb1, mb2, uri, name1,name2);
	    }

	}catch(Exception e2){
	    System.err.println("oops"+e2);
	}


//end second query
    }//end method
    

public void insertBatch(Vector paths){

	java.sql.ResultSet Recordset1 =null;
	java.sql.Driver DriverRecordset1=null;
	java.sql.Connection Connect=null;

	try{
	    

DriverRecordset1=(java.sql.Driver)Class.forName(driver).newInstance();

	Connect=java.sql.DriverManager.getConnection(pathdburi);
	    java.sql.Statement StatementRecordset1=Connect.createStatement();

		for (Iterator pathIterator = paths.iterator();
		     pathIterator.hasNext();)
		    {
			String path=(String)pathIterator.next();
//		        System.out.println("adding "+path);

			StatementRecordset1.addBatch(path);
		    }

		int [] updateCounts = StatementRecordset1.executeBatch();

	    StatementRecordset1.close();
	    Connect.close();
	}catch(Exception e){
	    System.err.println("oops"+e);
	    e.printStackTrace();
	}

    }



    public void insert(String q){

	java.sql.ResultSet Recordset1 =null;
	java.sql.Driver DriverRecordset1=null;
	java.sql.Connection Connect=null;
	
	try{
	    

DriverRecordset1=(java.sql.Driver)Class.forName("org.postgresql.Driver").newInstance();
	Connect=java.sql.DriverManager.getConnection("jdbc:postgresql://localhost:5432/newpaths?auth=password&user=postgres&password=notneeded");
	    java.sql.Statement StatementRecordset1=Connect.createStatement();
	    StatementRecordset1.executeUpdate(q);
	    StatementRecordset1.close();
	    Connect.close();
	    //System.out.println("adding "+q);
	}catch(Exception e){
	    System.err.println("oops"+e);
	    e.printStackTrace();
	}
	
    }


}//end class
