package org.ilrt.inkling.app;

import java.sql.*;
import java.util.*;
import org.ilrt.inkling.api.*;
import org.ilrt.inkling.query.*;

/*

Copyright Libby Miller, 2003.

*/

/*
<pre>
A little class that generates an SVG map of the locations of photos with
nearestAirports, using lat/long. The result is at
http://sw1.ilrt.org/discovery/2001/08/codepict/svgworldmap.svg

Based on the FOAF people map by Jim Ley:
http://jibbering.com/
http://jibbering.com/foaf/foaf-people-map.svg
</pre>
*/

public class SVGWorld{

public static void main (String args[]){

String
filen="/home/libby/rudolf/8080/2003-07-07/jakarta-tomcat-4.1.18/webapps/codepict/svgworldmap.svg";

StringBuffer sb = new StringBuffer();

sb.append("<?xml version=\"1.0\" ?>");
sb.append("<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 1.0//EN\" \n");
sb.append(" \"http://www.w3.org/TR/SVG/DTD/svg10.dtd\"> \n");

sb.append("<svg xmlns:a=\"http://ns.adobe.com/AdobeSVGViewerExtensions/3.0/\" \n");
sb.append("xmlns:xlink=\"http://www.w3.org/1999/xlink\" \n");
sb.append("xmlns=\"http://www.w3.org/2000/svg\" \n");
sb.append("zoomAndPan=\"magnify\"> \n");


sb.append("  <title>Places and Journeys from RDF</title> \n");

sb.append("  <image xlink:href=\"images/earth2.jpg\" height=\"1000\" \n");
sb.append("width=\"2000\" x=\"0\" y=\"0\"/> \n");

sb.append("<g transform=\"scale(5.555555555) translate(180 90)\" \n");
sb.append("viewbox=\"-180 90 180 -90\"> \n");
sb.append("  <g id=\"gel\" transform=\"scale(1,-1)\"> \n");


java.sql.ResultSet Recordset1 =null;

String query="";
String anno=null;
String mbox=null;
//String query=request.getParameter("query");  
//String anno=request.getParameter("anno");
//String mbox=request.getParameter("mbox");
//String template=null;
String db="jdbc:postgresql://localhost:5432/codepict?auth=password&user=postgres&password=notneeded";
db="jdbc:mysql://127.0.0.1:3306/codepict2?user=mysql";

SQLGraph s =new SQLGraph();
s.setDriver("com.mysql.jdbc.Driver");
s.setdb(db);

Vector urls=null;

if(anno!=null && (!anno.equals(""))){

query="select ?airport, ?lat, ?lo where "+
" (foaf:annotates ?doc ?pic) "+
" (foaf:maker ?doc ?per) "+
" (foaf:mbox_sha1sum ?per '"+anno+"') "+
" (foaf:creationEvent ?pic ?ev) "+
" (contact:nearestAirport ?ev ?airport) "+
//" (doa:location ?airport ?name) "+
" (geo:lat ?airport ?lat) "+
" (geo:long ?airport ?lo) "+
" using foaf for http://xmlns.com/foaf/0.1/ contact for "+
" http://www.w3.org/2000/10/swap/pim/contact# geo for "+
" http://www.w3.org/2003/01/geo/wgs84_pos# "+
" doa for http://www.daml.org/2001/10/html/airport-ont#";

}else if(mbox!=null && (!mbox.equals(""))){

query="select ?airport, ?lat, ?lo where "+
" (foaf:depicts ?pic ?per) "+
" (foaf:mbox_sha1sum ?per '"+mbox+"') "+
" (foaf:creationEvent ?pic ?ev) "+
" (contact:nearestAirport ?ev ?airport) "+
//" (doa:location ?airport ?name) "+
" (geo:lat ?airport ?lat) "+
" (geo:long ?airport ?lo) "+
" using foaf for http://xmlns.com/foaf/0.1/ contact for "+
" http://www.w3.org/2000/10/swap/pim/contact# geo for "+
" http://www.w3.org/2003/01/geo/wgs84_pos# "+
" doa for http://www.daml.org/2001/10/html/airport-ont#";


}else{

query="select ?airport, ?lat, ?lo where "+
" (geo:lat ?airport ?lat) "+
" (geo:long ?airport ?lo) "+
//" (doa:location ?airport ?name) "+
" (foaf:creationEvent ?pic ?ev) "+
" (contact:nearestAirport ?ev ?airport) "+
" using foaf for http://xmlns.com/foaf/0.1/ contact for "+
" http://www.w3.org/2000/10/swap/pim/contact# geo for "+
" http://www.w3.org/2003/01/geo/wgs84_pos# "+
" doa for http://www.daml.org/2001/10/html/airport-ont#";

}


try{

Recordset1=s.askSquish(query);

while (Recordset1.next()) {

String airport=(String)Recordset1.getString("airport");
String lat=(String)Recordset1.getString("lat");
String lo=(String)Recordset1.getString("lo");
//String name=(String)Recordset1.getString("name");
String name=airport.substring(36);


String airp=null;
if(anno!=null && (!anno.equals(""))){
airp="aboutairport.jsp?url="+airport+";anno="+anno;
}else{
airp="aboutairport.jsp?url="+airport;
}



sb.append("<a xlink:href=\""+airp+"\"> \n");
sb.append("<circle cx=\""+lo+"\" cy=\""+lat+"\" \n");
sb.append("r=\"0.6\" stroke=\"red\" stroke-width=\"0.11\" fill=\"yellow\" \n");
sb.append("opacity=\"0.6\" ref=\""+airport+"\" name=\""+name+"\" /></a> \n");
}

}catch(Exception ez){
//this is because of the tomcat problem

ez.printStackTrace();

}

sb.append(" <g id=\"popup\" transform=\"scale(2,1) translate(412.5,292.75) \n");
sb.append("scale(1)\"><text \n");
sb.append("transform=\"scale(1,2)\" style=\"stroke-width:0;fill:white;\" \n");
sb.append("startOffset=\"0\"/><text \n");
sb.append("y=\"1.5em\" transform=\"scale(1,2)\" \n");
sb.append("style=\"stroke-width:0;fill:white;\" \n");
sb.append("startOffset=\"0\"/></g> \n");
sb.append("</g></g></svg> \n");

org.ilrt.inkling.api.Util.save(filen,"",sb.toString());

}//end main


}//end class
