package org.ilrt.inkling.app;

import java.util.*;
import java.net.*;
import java.io.*;
import org.ilrt.inkling.api.*;
import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
<pre>
A Scutter RDF harvester (see http://rdfweb.org/topic/ScutterSpec)

todo:

- fix robots, forcelocal, etc etc

- sometimes gets stuck - timeout? - delete a thread when too old
(tmp fix - random waiting)
- randomlise urls list arnd remove duplicates
(ok)
- also robots.txt
- check local copy first
- add some more options
 - force check local copy
 - set db and driver
 - check scutterplan name out and in
- make choosable start and endfile.

- exclude some urls
- store url info in SQLdatabase
- check if visited before
</pre>
*/


public class Scutter{

public boolean forcelocal=false;
String 
dburi1="jdbc:postgresql://localhost:5432/codepict2?auth=password&user=postgres&password=notneeded";
String driver="org.postgresql.Driver";

Vector toavoid=new Vector();

Vector newplan=new Vector();
Vector threads = new Vector();

String uri="file:scutterplan.rdf";

public Scutter(){
newplan=new Vector();
}


/**
db is a JDBC database url, e.g.
jdbc:postgresql://localhost:5432/codepict2?auth=password&user=postgres&password=notneeded
or jdbc:mysql://127.0.0.1:3306/codepict2?user=mysql

*/

public Scutter(String db){
setdb(db);
}

public Vector getPlan(){
return newplan;
} 


public static void main(String args[]){


String
db="jdbc:mysql://127.0.0.1:3306/codepict2?user=mysql";

        Scutter s = new Scutter(db);
        s.setDriver("com.mysql.jdbc.Driver");
        s.runScutter();

/*
Scutter s = new Scutter();
System.out.println(s.robotSafe("http://swordfish.rdfweb.org/photos/genfiles/ilrt/714184670781893.rdf"));
*/

}

/**

reads a Scutterplan (e.g.
http://swordfish.rdfweb.org/discovery/2001/08/codepict/scutterplan.rdf
and runs a scutter over it, in a randomised order and with 10 threads

*/

public void runScutter(){

//toavoid.addElement("chat");
//toavoid.addElement("irc");
//toavoid.addElement("iris");
//toavoid.addElement("london.pm.org"); 
//toavoid.addElement("pubs"); 
//toavoid.addElement("http://jibbering.com/rdfweb/1016746423488.rdf");


Vector v=readScutter(uri);
//System.out.println("[00]"+v);

System.out.println("FOUND "+v.size()+" urls to scutter");
System.out.println("STATUS "+forcelocal);

int count=0;

Enumeration e = v.elements();
	while(e.hasMoreElements()){
	ScutterURLData data = (ScutterURLData)e.nextElement();

	Random rand = new Random();
	data.setScutter(this);


	   try{
		if(threads.size()>=10){
		long l=new Long(Math.abs(rand.nextInt(6000))).longValue();
		Thread.currentThread().sleep(l);
		System.out.println("sleeping "+l+","+threads.size());
		}else{
System.out.println("STARTING url "+count+", "+data.getUrl());
		Thread thr = new Thread(data);
		thr.start();
		}
	   }catch(java.lang.InterruptedException ie){
		System.err.println("thread problem in Scutter "+ie);
	   }
	count++;

	}


//System.out.println("nnnn"+newplan.size());

checkDone(0);

}//end runscutter


/**

Checks if all the threads are finished and can save the scutterplan

*/

public void checkDone(int i){

i++;
	Random rand = new Random();

	if(threads.size()==0){
	System.out.println("SAVING scutterplan "+newplan.size());
	saveScutter(newplan, "file:scutterplan.new2.rdf");
	}else{
	System.out.println("SIZE "+threads.size());
		try{
		long l=new Long(Math.abs(rand.nextInt(6000))).longValue();
		Thread.currentThread().sleep(l);
/*

			if(i>3){//hack
			Thread.currentThread().interrupt();
			System.out.println("killed");
			}
*/
		System.out.println("SLEEPING "+l);
		checkDone(i);
		}catch(java.lang.InterruptedException ex){
		System.err.println("thread problem in Scutter "+ex);
		}
	}


}


/**

Makes sure this one is not a url to avoid scuttering. be nice to expand
this to use filters for certain types of file e.g. images file, foaf
files.

*/

public boolean checkAvoid(String url){
boolean ok=true;
	Enumeration ee= toavoid.elements();
	while(ee.hasMoreElements()){
	String toa=(String)ee.nextElement();
//System.out.println("looking at "+toa+" and "+url);
		if(url.indexOf(toa)!=-1){
		ok=false;
		break;
		}
//System.out.println("ok "+ok);

	}
return ok;
}

/**

Reads in a scutterplan, creating a ScutterUrlData for each url, and
returning a Vector of these.

*/

public  Vector readScutter(String uri){

Vector vec = new Vector();

//System.out.println("found a url "+uri);
String query="select ?url, ?etag, ?lm "+
" where (rdfs:seeAlso "+uri+" ?url) "+
//" (scutter:etag ?url ?etag) "+
//" (scutter:lastmodified ?url ?lm) "+
" using rdfs for http://www.w3.org/2000/01/rdf-schema# "+
" scutter for http://www.hackdiary.com/scutter/";

        Graph gr = new Graph(null, uri, Util.RDFXML);
        ComplexQuery cq=(ComplexQuery)SquishParser.parse(query);
        cq.getGraphs().addElement(gr);
        QE qe=new QE();
        java.sql.ResultSet r1=qe.executeQuery(cq);
Vector urlsvec= new Vector();
	try{
	while (r1.next()) {
	String url=(String)r1.getString("url");
		if(!vec.contains(url)){
			if(robotSafe(url)){
			vec.addElement(url);
			ScutterURLData surl=new ScutterURLData(url);

//move lower
			urlsvec.addElement(surl);
			}else{
			toavoid.addElement(url);
			}
		}

	System.out.println("Url "+url);
//	String etag=(String)r1.getString("etag");
//	String lm=(String)r1.getString("lm");
	}//end while

/*
String query2="select  ?etag, ?lm "+
" where (scutter:etag "+url+" ?etag) "+
" (scutter:lastmodified "+url+" ?lm) "+
" using rdfs for http://www.w3.org/2000/01/rdf-schema# "+
" scutter for http://www.hackdiary.com/scutter/";


        ComplexQuery cq2=(ComplexQuery)SquishParser.parse(query2);
        cq2.getGraphs().addElement(gr);
        QE qe2=new QE();
        java.sql.ResultSet r2=qe2.executeQuery(cq2);

		if (r2.next()) {
		String etag=(String)r2.getString("etag");
		String lm=(String)r2.getString("lm");
		ScutterURLData surl=new ScutterURLData(url,lm,etag );
		urlsvec.addElement(surl);
		}else{
		ScutterURLData surl=new ScutterURLData(url);
		urlsvec.addElement(surl);
		}
*/

//	}


	}catch(Exception y){
	System.err.println(y);
	}
/*
Vector v =
gr.ask(uri,"http://www.w3.org/2000/01/rdf-schema#seeAlso",null);

//for each of these, find etag and lastmodified, put in ScutterURLData
Vector urlsvec= new Vector();

Enumeration e =v.elements();

	while(e.hasMoreElements()){

	Statement st = (Statement)e.nextElement();


	}
*/
//System.out.println("COUNT "+urlsvec.size());
Random rand = new Random();
Collections.shuffle(urlsvec,rand);
return urlsvec;
}


/**

Saves Scutterplan with the filename specified

*/

public  void saveScutter(Vector newplan, String filen){

StringBuffer rdf=new StringBuffer();

Enumeration ez = newplan.elements();
while(ez.hasMoreElements()){
	ScutterURLData s =(ScutterURLData)ez.nextElement();

	String val=s.getUrl();

		int i=val.indexOf("&");
		int j=val.indexOf("&amp;");

//System.out.println("iiii "+i+" j "+j);
		if(i!=-1 && j==-1){
		val=Util.replace(val,"&","&amp;");
		}

	rdf.append("<rdfs:seeAlso>\n<rdf:Description rdf:about='");
	rdf.append(val);
	rdf.append("'>\n");
	rdf.append(" scutter:etag='");
	rdf.append(s.etagEscString());
	rdf.append("'>\n");
	rdf.append(" <scutter:lastmodified>");
	rdf.append(s.dateToString());
	rdf.append("</scutter:lastmodified>\n");
	rdf.append("</rdf:Description>\n</rdfs:seeAlso>\n");
	//System.out.println(val);
}

String finalstr="<?xml version='1.0' ?>\n"+
"<rdf:RDF  xmlns:rdf='http://www.w3.org/1999/02/22-rdf-syntax-ns#'\n"+  
" xmlns:scutter='http://www.hackdiary.com/scutter/'\n"+
" xmlns:rdfs='http://www.w3.org/2000/01/rdf-schema#' >\n"+
"<rdf:Description rdf:about=''>\n"+rdf+"</rdf:Description>\n</rdf:RDF>\n";

Util.save(filen,"",finalstr);

}


/**

adds a single url to the store and a scutterplan called
'scutter.new2.rdf'

*/

public  void addSingleUrl(String url){
Graph gr=null;
SQLGraph sq=new SQLGraph();

if(url!=null && (!url.equals(""))){
url=url.trim();

//testing!
	if(forcelocal){
	String yy="file:scutter/"+Util.sha1(url);
	System.out.println("LOCAL "+url+" "+yy);
	File f = new File("scutter/"+Util.sha1(url));
		if(f.exists()){
		gr = new Graph(null, yy, Util.RDFXML);
		}else{
		gr = new Graph(null, "", Util.RDFXML);
		}
	}else{
	System.out.println("REMOTE "+url);
	gr = new Graph(null, url, Util.RDFXML);
	}

gr.load();

sq.setDriver(driver);
sq.setdb(dburi1);
sq.add(gr);

    if(gr!=null && gr.getSize()>0){

	Vector v = readScutter("file:scutterplan.new.rdf");

//	if(!v.contains(url)){
//	v.addElement(url);
	ScutterURLData surl=new ScutterURLData(url);
	v.addElement(surl);
//	}

	saveScutter(v, "file:scutterplan.new.rdf");

/*
//System.out.println("ok");
    String s = Util.readFile(uri);
//System.out.println("ok again "+s);
    int i=s.indexOf("</rdf:Description>");
//System.out.println("i is "+i);
	if(i!=-1){
//System.out.println("ok again again "+url);
	s=s.substring(0,i)+"<rdfs:seeAlso rdf:resource='"+url+"'/>\n"+s.substring(i);
	Util.save(uri,"",s);

	}
*/

    }


}//end if

}//end method

/**

etag methods - 
from http://www.hackdiary.com/archives/000028.html by Matt Biddulph

*/

public boolean checkModified(ScutterURLData data){

long lastmodified;
String etag;
String url;

boolean bool = false;
URL u =null;
URLConnection connection = null;



try{
System.out.println("URL "+data.getUrl());
System.out.println("etag "+data.getEtag());
u= new URL(data.getUrl());
connection=u.openConnection(); 

if(connection instanceof HttpURLConnection){
HttpURLConnection httpCon = (HttpURLConnection)connection;
httpCon.setRequestProperty("If-None-Match", data.getEtag());
httpCon.setIfModifiedSince(data.getLastModified());
httpCon.connect();

boolean savef=true;

	if(savef){

	InputStream in = httpCon.getInputStream();
	ByteArrayOutputStream bos = new ByteArrayOutputStream();
	int i;
		while((i = in.read())!= -1)
		{
		bos.write(i);
		}
	
	byte [] b = bos.toByteArray();
	
	FileOutputStream fos = new
FileOutputStream("scutter/"+Util.sha1(data.getUrl()));
System.out.println("saving "+"file:scutter/"+Util.sha1(data.getUrl()));
	fos.write(b);
	fos.close();
	httpCon.disconnect();

	}

	if(httpCon.getResponseCode() == HttpURLConnection.HTTP_OK) {
	data.setEtag(httpCon.getHeaderField("ETag"));
	data.setLastModified(httpCon.getHeaderFieldDate("Last-Modified",0));
	bool=true;
	}
	else if(httpCon.getResponseCode() == HttpURLConnection.HTTP_NOT_MODIFIED) {
	}else{
	}

}else{
}

}catch(Exception e){
System.out.println("scutter url data problem "+e);
//e.printStackTrace();
}


return bool;
}//end method


public void setdb(String db){
this.dburi1=db;
}

public void setDriver(String driver){
this.driver=driver;
}

public String getdb(){
return dburi1;
}

public String getDriver(){
return driver;
}

public Vector getThreads(){
return threads;
}

public static final String DISALLOW = "Disallow:";

/**

robots.txt handling

*/


public boolean robotSafe(String u){
/*
if(forcelocal){
return true;
}else{

//see http://developer.java.sun.com/developer/technicalArticles/ThirdParty/WebCrawler/WebCrawler.java
URL url=null;
	try{
	url = new URL(u);
	}catch(MalformedURLException e){
	return false;
	}

	String strHost = url.getHost();

	// form URL of the robots.txt file
	String strRobot = "http://" + strHost + "/robots.txt";
	URL urlRobot;
	try { 
	    urlRobot = new URL(strRobot);
	} catch (MalformedURLException e) {
	    // something weird is happening, so don't trust it
	    return false;
	}

	String strCommands;
	try {
	    InputStream urlRobotStream = urlRobot.openStream();

	    // read in entire file
	    byte b[] = new byte[1000];
	    int numRead = urlRobotStream.read(b);
	    strCommands = new String(b, 0, numRead);
	    while (numRead != -1) {
		numRead = urlRobotStream.read(b);
		if (numRead != -1) {
		    String newCommands = new String(b, 0, numRead);
		    strCommands += newCommands;
		}
	    }
	    urlRobotStream.close();
	} catch (IOException e) {
	    // if there is no robots.txt file, it is OK to search
	    return true;
	}

	// assume that this robots.txt refers to us and 
	// search for "Disallow:" commands.
	String strURL = url.getFile();
	int index = 0;
	while ((index = strCommands.indexOf(DISALLOW, index)) != -1) {
	    index += DISALLOW.length();
	    String strPath = strCommands.substring(index);
	    StringTokenizer st = new StringTokenizer(strPath);

	    if (!st.hasMoreTokens())
		break;
	    
	    String strBadPath = st.nextToken();

	    // if the URL starts with a disallowed path, it is not safe
	    if (strURL.indexOf(strBadPath) == 0)
		return false;
	}

	return true;
}
*/

return true;

}



}//end class

