package org.ilrt.inkling.app;

import org.ilrt.inkling.api.*;
import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.text.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/


/**
<pre>
A class representing information aboput a url, including etag,
lastmodified etc. Runs as a thread in Scutter. Saves itself to a sha1ed
hash of the file name locally for comparison:
file:scutter/"+Util.sha1(toget)
</pre>
*/

public class ScutterURLData implements Runnable{

  SimpleDateFormat df = new SimpleDateFormat("EEE, d MMM yyyy HH:mm:ss z");
String url=null;
long lastmodified=0;
String etag=null;
Scutter s = new Scutter();

public ScutterURLData(String url,long lastm,String etag){
setUrl(url);
setLastModified(lastm);
setEtag(etag);
}

public ScutterURLData(String url,String lastm,String etag){
setUrl(url);
setLastModifiedString(lastm);
setEtag(etag);
}

public ScutterURLData(String url){
setUrl(url);
setLastModified(0);
setEtag("");
}

public String getUrl(){
return url;
}
public void setUrl(String url){
this.url=url;
}

public long getLastModified(){
return lastmodified;
}

public void setLastModified(long l){
lastmodified=l;
}

public void setLastModifiedString(String s){
//DateFormat.getDateInstance();
	try{
	long l=df.parse(s).getTime();
	lastmodified=l;
	}catch(Exception e){
	System.err.println(e);
	}
}

public String getEtag(){
return etag;
}


public void setEtag(String etag){
/*
if(etag.startsWith("\"")){
etag=etag.substring(1);
}
if(etag.endsWith("\"")){
etag=etag.substring(0,etag.length());
}
*/
this.etag=etag;
}

public String etagEscString(){
//System.out.println("!!!!!"+etag);
String newetag="";
if(etag!=null && (!etag.equals("")) && etag.length()>2){
	if(etag.startsWith("\"")||etag.startsWith("\'")){
	newetag="&quot;"+etag.substring(1);
	}

	if(etag.endsWith("\"")||etag.endsWith("\'")){
	if(newetag.length()>0){
	newetag=newetag.substring(0,newetag.length()-1)+"&quot;";
	}
	}
}
//System.out.println("!!!!!"+newetag);

return newetag;
}

public String dateToString(){
Date d= new Date(lastmodified);
return df.format(d);
}



public void setScutter(Scutter s){
this.s=s;
}

public Scutter getScutter(){
return s;
}

public void run(){

Vector newplan=s.getPlan();
Vector threads=s.getThreads();
threads.addElement(this);

	if(checkModified()){
	String toget=this.getUrl();

//fix encoding
	try{

System.out.println("GOT "+toget);

        Graph gr = null;

//new Graph(null, toget, Util.RDFXML);


//testing!
        if(s.forcelocal){  
        String yy="file:scutter/"+Util.sha1(toget);
        File f = new File("scutter/"+Util.sha1(toget));
        System.out.println("LOCAL "+toget+" "+"scutter/"+Util.sha1(toget));

                if(f.exists()){
                gr = new Graph(null, yy, Util.RDFXML);
                }
/*
		else{
	        gr = new Graph(null, "", Util.RDFXML);
                }
*/
        }else{
        System.out.println("REMOTE "+toget);
        gr = new Graph(null, toget, Util.RDFXML);
        }

        gr.load();
	
//tmp - for now. no loading//if del no actual loadiung
//===
	SQLGraph sgr = new SQLGraph();
        sgr.setdb(s.getdb());
	sgr.setDriver(s.getDriver());

System.out.println("starting to add "+toget+" "+Util.sha1(toget));
	sgr.add(gr);
System.out.println("finshed adding "+toget+" "+Util.sha1(toget));
//===

//	Graph tmpg=new Graph(sgr.getStatements(),toget);	
//System.out.println("size "+tmpg.getSize());

//		if(sgr.getSize()>0){
//		if(tmpg.getSize()>0){
		if(gr.getSize()>0){

		//get seealsos
		String query="select ?uu where "+
"(http://www.w3.org/2000/01/rdf-schema#seeAlso ?any ?uu)";
//System.out.println("okey "+query);

/*
	        ComplexQuery cq=(ComplexQuery)SquishParser.parse(query);
	        cq.getGraphs().addElement(tmpg);
	        QE qe=new QE();
	        java.sql.ResultSet rs=qe.executeQuery(cq);
*/
		java.sql.ResultSet rs=gr.askSquish(query);

			while(rs.next()){
			String seea=(String)rs.getString("uu");
//			System.out.println("ok"+seea);

//this shoudl never ever happen....
				ScutterURLData sud=new ScutterURLData(seea);
				if(!newplan.contains(sud)){
				newplan.addElement(sud);
				}
			}

			if(!newplan.contains(this)){
			//System.out.println("!!!![1]"+newplan.size());
			newplan.addElement(this);
			//System.out.println("!!!![2]"+newplan.size());
			}
		}else{
		//save it somewhere....
		}

	}catch(Exception er){
	System.out.println("OK "+er);
	er.printStackTrace();
	}finally{

System.out.println("removing "+this+" "+threads.size());
	   threads.remove(this);
System.out.println("removed "+threads+" "+threads.size());
	}

	}//end if
	else{
//add it to the plan anyway
		newplan.addElement(this);
	}

//System.out.println("removing "+this+" "+threads.size());
//   threads.remove(this);
//System.out.println("removed "+threads+" "+threads.size());

}//end method

/**

from http://www.hackdiary.com/archives/000028.html by Matt Biddulph

*/

public boolean checkModified(){
/*
long lastmodified;
String etag;
String url;

boolean bool = false;
URL u =null;
URLConnection connection = null;

try{
System.out.println("URL "+this.getUrl());
System.out.println("etag "+this.getEtag());
u= new URL(this.getUrl());
connection=u.openConnection(); 

if(connection instanceof HttpURLConnection){
HttpURLConnection httpCon = (HttpURLConnection)connection;
httpCon.setRequestProperty("If-None-Match", this.getEtag());
httpCon.setIfModifiedSince(this.getLastModified());
httpCon.connect();

boolean savef=true;

if(savef){

InputStream in = httpCon.getInputStream();
ByteArrayOutputStream bos = new ByteArrayOutputStream();
int i;
	while((i = in.read())!= -1)
	{
		bos.write(i);
	}
	
	byte [] b = bos.toByteArray();
	
	FileOutputStream fos = new
FileOutputStream("scutter/"+Util.sha1(this.getUrl()));
System.out.println("saving "+"file:scutter/"+Util.sha1(this.getUrl()));
	fos.write(b);
	fos.close();
	httpCon.disconnect();

}

	if(httpCon.getResponseCode() == HttpURLConnection.HTTP_OK) {
	this.setEtag(httpCon.getHeaderField("ETag"));
	this.setLastModified(httpCon.getHeaderFieldDate("Last-Modified",0));
	bool=true;
	}
	else if(httpCon.getResponseCode() == HttpURLConnection.HTTP_NOT_MODIFIED) {
	}else{
	}

}else{
}

}catch(Exception e){
System.out.println("scutter url data problem "+e);
//e.printStackTrace();
}
System.out.println("BOOOL "+bool);
return bool;
*/
return true;//for now
}//end method

//to make ssure no dups

public boolean equals(Object s){

	if(s instanceof ScutterURLData){
		if (((ScutterURLData)s).getUrl().equals(this.getUrl())
){
		return true;
		}else{
		return false;
		}
	}else{
	return false;
	}
}

}//end class

