package org.ilrt.inkling.app;

import org.ilrt.inkling.api.*;
import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;
import java.util.*;
import java.io.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
this is a rough pass at a testing framework for RDFQuery. More recent
version (not finished) is RDFQueryTests.java
*/


public class TestFramework {

boolean ntriples=true;

static String rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#";
static String rsvocab="http://jena.hpl.hp.com/2003/03/result-set#";
static String tq="http://www.w3.org/2003/03/rdfqr-tests/query.rdfs#";
static String mf="http://www.w3.org/2003/03/rdfqr-tests/manifest.rdfs#";

static ComplexQuery cq = new ComplexQuery();

    public static void main(String args[]) {

		String manifestFile="file:rdf/query-results-manifest.rdf";
		String outputBaseFile="file:test/base";
		String inputBaseFile="file:jenatests/rdql-tests-2003-04-10";

		if(args!=null)
		{
			if(args.length==1)
			{

				manifestFile=args[0];
			}

			if(args.length==2)
			{

				manifestFile=args[0];
				outputBaseFile=args[1];
				if(outputBaseFile.endsWith("/")){
				outputBaseFile=outputBaseFile.substring(0,outputBaseFile.length()-1);
				}

			}
			if(args.length==3)
			{

				manifestFile=args[0];
				outputBaseFile=args[1];
				inputBaseFile=args[2];
				if(outputBaseFile.endsWith("/")){
				outputBaseFile=outputBaseFile.substring(0,outputBaseFile.length()-1);
				}
				if(inputBaseFile.endsWith("/")){
				inputBaseFile=inputBaseFile.substring(0,inputBaseFile.length()-1);
				}
			}
		}

		cq= new ComplexQuery();

		Graph gr = new Graph(null, manifestFile, Util.RDFXML);
		gr.load();
		Vector tt=gr.getStatements();
		//System.out.println("Size is "+tt.size());
		Graph g=gr;

		Vector results=g.ask(null, rdf+"type", mf+"Test" );	
		

//read in the manifest file, and find
//num, name, description, inputDocument, queryDocument
//outputDocument, numberRows

		for (Iterator iterator = results.listIterator(); iterator.hasNext();) 
		{
		Node test=((Statement) iterator.next()).getSubject();

//better api for this sort of thing?
		System.out.println("\nname: "+((Statement)(g.ask(test, mf+"name", 
		null)).elements().nextElement()).getObject().getContent());	

		System.out.print("description: "+((Statement)(g.ask(test, 
		mf+"description", null)).elements().nextElement()).getObject().getContent());	

		System.out.println("status: "+((Statement)(g.ask(test, mf+"status", 
		null)).elements().nextElement()).getObject().getContent());	

		Node input=((Statement)(g.ask(test, mf+"input",
		null)).elements().nextElement()).getObject();

		Node queryDocName=((Statement)(g.ask(input, tq+"queryDocument",
		null)).elements().nextElement()).getObject();

		Node queryDocType=((Statement)(g.ask(queryDocName, rdf+"type",
		null)).elements().nextElement()).getObject();

//		System.out.println("query: "+queryDocName.getContent());
//		System.out.println("type: "+queryDocType.getContent());

//may be several input docs

		Hashtable sources=new Hashtable();

		Vector inputDocs=g.ask(input, tq+"inputDocument",null);

			for (Iterator iterator2 = inputDocs.listIterator(); iterator2.hasNext();)
			{

			Node source=((Statement) iterator2.next()).getObject();

			Node sourceDocType=((Statement)(g.ask(source, rdf+"type",
			null)).elements().nextElement()).getObject();
	
			//System.out.println("source: "+source.getContent());
			//System.out.println("type: "+sourceDocType.getContent());

			sources.put(source.getContent(),sourceDocType.getContent());
			}

//one output doc with type and numberRows

		Node output=((Statement)(g.ask(test, mf+"output",
		null)).elements().nextElement()).getObject();

		Node outputDocName=((Statement)(g.ask(output, tq+"outputDocument",
		null)).elements().nextElement()).getObject();

		Node outputDocType=((Statement)(g.ask(outputDocName, rdf+"type",
		null)).elements().nextElement()).getObject();

		Node outputNumberRows=((Statement)(g.ask(outputDocName, tq+"numberRows",
		null)).elements().nextElement()).getObject();

		//System.out.println("output document: "+outputDocName.getContent());
		//System.out.println("type: "+outputDocType.getContent());
		//System.out.println("expected number rows: "+outputNumberRows.getContent());

//read in the resultset as provided to find out the var names we want

		String outdocn=outputDocName.getContent();

		        if (outdocn.startsWith("file:")) {
		            outdocn = outdocn.substring(5); 
		        }


		Graph res = new Graph(null, inputBaseFile+"/"+outdocn, 
		outputDocType.getContent());
		res.load();

		Vector bla=res.ask(null, rsvocab+"resultVariable", null);
		Vector variablesWeWant=new Vector();

///this is a problem
//I am using this info to find out the vars we want;
//but in alberto's  testcase, 

			for (Iterator iterator3 = bla.listIterator(); iterator3.hasNext();)
			{
			Node varwewant=((Statement) iterator3.next()).getObject();	
			variablesWeWant.addElement(varwewant.getContent());
			}


//make the query
//sql and local

		String filen=queryDocName.getContent();
		String filetype=queryDocType.getContent();

		QE qe = new QE();
		ComplexQuery complexQuery=null;

  
		        if (filen.startsWith("file:")) {
		            filen = filen.substring(5); 
		        }


			if(filetype.equals("http://www.w3.org/2003/03/rdfqr-tests/query.rdfs#RDF-XML-Document")){
			NTReader ntr1= new NTReader();
			complexQuery=ntr1.parseToQuery(inputBaseFile+"/"+filen);
			}else if(filetype.equals("http://www.w3.org/2003/03/rdfqr-tests/query.rdfs#NT-Document")){

			NTReader ntr1= new NTReader();
			complexQuery=ntr1.parseToQuery(inputBaseFile+"/"+filen);

			}else if(filetype.equals("http://www.w3.org/2003/03/rdfqr-tests/query.rdfs#Squish-Document")){
			SquishParser sp=new SquishParser();
			complexQuery=sp.parse(readQuery(inputBaseFile+"/"+filen));//can squishparser be complexquery? 
			}else{
			System.err.println("TF: unrecognised query format "+filetype);
			System.err.println("skipping to next query");
			}

		if(complexQuery!=null){

		Enumeration eh=sources.keys();
			while(eh.hasMoreElements()){
			String key=(String)eh.nextElement();

			String val=(String)sources.get(key);

			        if (key.startsWith("file:")) {
			            key = key.substring(5); 
			        }


			complexQuery.getGraphs().addElement(new 
 			Graph(null,inputBaseFile+"/"+key,val));

			}

			if(variablesWeWant.size()!=0){
			//System.out.println("variables we want "+variablesWeWant);
			complexQuery.setVariablesWeWant(variablesWeWant);
			}

		java.sql.ResultSet rs=qe.executeQuery(complexQuery);

		//System.out.println("rs "+rs);

//probably shouldnt save to the content name - this is for comparison

		String outfile=outputDocName.getContent();

		String savefile=outfile.substring(outfile.lastIndexOf("/"),outfile.lastIndexOf("."));
		savefile=savefile+".rdf";

//		System.out.println("Saving to "+outputBaseFile+""+savefile);

		Util.save(outputBaseFile+savefile,"",((org.ilrt.inkling.query.ResultSet)rs).toRDFString());

//System.out.println(((org.ilrt.inkling.query.ResultSet)rs).toRDFString());

//check the results via the file
//(could do this via jena graph match - makefile? poss prob w base)

//try a simple comparsion of num rows

		Graph newres = new Graph(null, outputBaseFile+"/"+savefile,Util.RDFXML);
		newres.load();

		Node newOutputNumberRows=new Node();
		int nr1=-1;
		int nr2=-1;

			try{
			newOutputNumberRows=((Statement)(newres.ask(null,
			rsvocab+"size", null)).elements().nextElement()).getObject();
			nr1= (new Integer(outputNumberRows.getContent())).intValue();
			nr2= (new Integer(newOutputNumberRows.getContent())).intValue();
			}catch(Exception e){
			System.out.println("error - no size in new RS");
			}


		//System.out.println("actual number of rows: "+newOutputNumberRows.getContent());

			if(nr1==nr2 && nr1!=-1){
			System.out.println ("MATCH! "+queryDocName.getContent()+" "+nr1+" "+nr2);
			}else{
			System.out.print("ERROR! "+queryDocName.getContent()+" "+nr1+" "+nr2+" ");
			if( nr2==-1){
			System.out.println("reason  - number rows is missing from orginal manifest"); 
			}
		}

		}//end if cq !=null
//System.out.println("1 "+nr1+" 2 "+nr2);
	}

    }//end method


    public static String readQuery(String filename) {


        if (filename.startsWith("file:")) {
            filename = filename.substring(5);
        }


        //System.out.println("trying to read "+filename);

        StringBuffer sb = new StringBuffer();
        BufferedReader br = null;
        try {
            br = new BufferedReader(new FileReader(filename));
            String line;
            while ((line = br.readLine()) != null) {
                if (!line.equals("") && (!line.startsWith("#"))) {
                    sb.append("\n"+line);
                }
            }
        } catch (Exception ee) {
            System.err.println("\nerror " + ee);
        }
        try {
            br.close();
        } catch (Exception ene) {
            System.out.println("cannot close " + ene);
        }

        return sb.toString();

    }



    public static String toNT(String url, Vector graphs) {

        int i = url.lastIndexOf("/");
        String newUrl =
                url.substring(0, i + 1) + "nt"+url.substring(i) + ".nt";
        return newUrl;
    }



    public static String toInkling(){

        String comment =
                "\n\nInkling:\nThis conversion does not do shortened "+
                "namespaces or picking out the variables you want.\n\n";

        System.out.println(comment);

        String s = "SELECT ";

        Enumeration a = cq.getVariablesWeWant().elements();
        int si = cq.getVariablesWeWant().size();
        int i = 1;

        while (a.hasMoreElements()) {
            s = s + "?"+(String) a.nextElement();
            if (i < si) {
                s = s + ", ";
            }
            i++;
        }

        boolean source = false;
        boolean ns = false;

        //is graphs optional? can you have more than one? - assume one for now
        if (cq.getGraphs() != null) {

            int count = cq.getGraphs().size();
            int bla = 1;
            Enumeration e = cq.getGraphs().elements();
            while (e.hasMoreElements()) {
                s = s + "\nFROM "+e.nextElement().toString();
                if (count < bla) {
                    s = s + ", \n";
                }
            }

        }

        s = s + "\nWHERE ";

        Enumeration e = cq.getTriples().elements();

        while (e.hasMoreElements()) {

            Query p = (Query) e.nextElement();

            if (p.getPredicate() != null) {
                s = s + "\n   ("+p.getPredicate().getContent();
            } else {//can you have prd variables? probably...
                s = s + "\n   (?"+p.getPredicateVariable();
            }

            if (p.getSubject() != null) {
                s = s + " "+p.getSubject().getContent();
            } else {
                s = s + " ?"+p.getSubjectVariable();
            }

            if (p.getObject() != null) {
                s = s + " "+p.getObject().getContent();
            } else {
                s = s + " ?"+p.getObjectVariable() + ")";
            }

        }


        return s;
    }


public static void parseNT(String nt){

       NTReader ntr=new NTReader();

        cq=ntr.parseStringToQuery(nt);
//        variables=ntr.getVariables();
}

}

