package org.ilrt.inkling.external;

import com.hp.hpl.jena.rdf.arp.*;
import org.xml.sax.InputSource;
import org.ilrt.inkling.api.*;
import java.util.*;
import java.net.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
<pre>
A class to use the ARP RDF/XML parser (part of Jena:
http://www.hpl.hp.com/semweb/jena.htm)
</pre>
*/

public class ARPWrapper implements LoaderInterface {

    ARP parser;
    String base = null;

    public ARPWrapper() {
        parser = new ARP();
    }


    //help!

    public void setBase(String base) {
        this.base = base;
    }


    public void parse(java.io.InputStream source, GraphInterface consumer) {

System.out.println("PARSING with ARP");
        try {

            consumer.setBase(base);

            parser.setStatementHandler(
                    new TalkToARP(consumer));
            if (base != null) {
                parser.load(source, base);
            } else {
                parser.load(source);
            }
        } catch (Exception e) {
            System.err.println("parser loading failed "+e);
        }

    }

    /*
     public void setErrorHandler(ErrorHandler handler){
     errorHandler=handler;
     parser.setErrorHandler(handler);
     }

     */

    public GraphInterface loadGraph(String url){
            GraphInterface rdf =
                    new Graph(new Vector());

        return loadGraph(url,rdf);  
    }


    public GraphInterface loadGraph(String url, GraphInterface graph){

        if (url != null) {

            ARPWrapper parser = new ARPWrapper();
            InputSource source = null;
            GraphInterface consumer = null;
   	    consumer = null;
            try {
                consumer = (GraphInterface) graph;
                consumer.setBase(url);
                URL uu = new URL(url);
                parser.setBase(url);
                if (consumer != null && uu != null) {
                    parser.parse(uu.openStream(), consumer);
                }

            } catch (Exception e1) {
                System.err.println(
                        "Download :something wrong ARP[3]" + e1);
                e1.printStackTrace();
            }
            return graph;
        }
        else {
            System.out.println("Parser - nothing returned 1");
            return null;
        }


    }

}
