package org.ilrt.inkling.external;

import com.hp.hpl.jena.rdf.arp.*;
import java.util.*;
import org.ilrt.inkling.api.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**

<pre>
Companion to ARPWrapper - converts between ARP and Tinkling objects.
</pre>
*/


public class TalkToARP implements com.hp.hpl.jena.rdf.arp.StatementHandler {

public static void main(String args[]){
TalkToARP tta = new TalkToARP((GraphInterface)new Graph());

}

//graph? how we get graph id?
    Random ran = new Random();
    GraphInterface consumer;
    boolean started = false;

    public TalkToARP(GraphInterface consumer) {
        this.consumer = consumer;
    }

    public void end() {
        started = false;
    }

    public Node translate(AResource arpResource) {

		if(arpResource.isAnonymous()){
		Node node = Node.getBlank(arpResource.getAnonymousID(), (Graph)consumer);
		return node;		
		}else{
		Node node = Node.getResource(arpResource.getURI(),(Graph)consumer);
		return node;		
		}
    }


    public Node translatePredicate(AResource arpResource) {

	Node node = Node.getResource(arpResource.getURI(),(Graph)consumer);
        return node;
    }


    public Node translate(ALiteral arpLiteral) {
	Node node = Node.getLiteral(arpLiteral.toString(),(Graph)consumer);
	return node;
    }


    public void tell(Node s, Node p, Node o){

        try {
//	System.out.println("telling "+consumer+" "+s+" "+p+" "+o+"\n\n");
	    consumer.tell(new Statement(s,p,o));
        } catch (Exception e) {
            System.err.println("oops can't add statement");
            System.err.println("sub "+s.toString() + " p "+
                    p.toString() + " o "+o.toString());
            System.err.println(e);
        }

    }

    public void statement(AResource arpSubject, AResource arpPredicate,
            AResource arpObject) {

        try {
            tell(translate(arpSubject),
                    translatePredicate(arpPredicate), translate(arpObject));
        } catch (Exception ez) {
            System.err.println(ez);
        }

    }

    public void statement(AResource arpSubject, AResource arpPredicate,
            ALiteral arpLiteral) {

        try {
            tell(translate(arpSubject),
                    translatePredicate(arpPredicate),
                    translate(arpLiteral));
        } catch (Exception ez) {
            System.err.println(ez);
        }

    }


}
