package org.ilrt.inkling.external;

import java.io.*;
import java.util.*;
import org.ilrt.inkling.api.*;
import nl.aidministrator.rdf.io.rdfxml.*;
import nl.aidministrator.rdf.model.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
<pre>
Companion to RioWrapper, converting Rio objects to Tinkling ones
</pre>
*/

public class TalkToRio implements 
nl.aidministrator.rdf.io.StatementHandler{

public static void main(String args[]){

TalkToRio tta = new TalkToRio((GraphInterface)new Graph());
}

int count=0;

    GraphInterface consumer;
    boolean started = false;

    public TalkToRio(GraphInterface consumer) {
        this.consumer = consumer;
    }

    public void end() {
        started = false;
    }

    public void handleStatement(Resource subject,
                            URI predicate,
                            Value object){

        try {
            tell(translateValue(subject),
	translatePredicate(predicate),translateValue(object));
        } catch (Exception ez) {
            System.err.println(ez);
        }


    }	

    public Node translateValue(Value val) {

	if(val instanceof nl.aidministrator.rdf.model.Resource){

		if(val instanceof nl.aidministrator.rdf.model.BNode){
		Node node=Node.getBlank(((BNode)val).getID(),(Graph)consumer);
		return node;		
		}else{
		Node node=Node.getResource(((URI)val).getURI(),(Graph)consumer);
		return node;		
		}
	}else{
	count++;
	Node node=Node.getLiteral(((Literal)val).getLabel(),(Graph)consumer);
	return node;		
	}
    }


    public Node translatePredicate(URI predicate) {

	Node node =Node.getResource(predicate.getURI(),(Graph)consumer);
        return node;
    }


    public void tell(Node s, Node p, Node o){

        try {
//		System.out.println("telling "+s+" "+p+" "+o+"\n\n");
	    consumer.tell(new Statement(s,p,o));
        } catch (Exception e) {
            System.err.println("oops can't add statement");
            System.err.println("sub "+s.toString() + " p "+
                    p.toString() + " o "+o.toString());
            System.err.println(e);
        }

    }

/*
    public void statement(AResource arpSubject, AResource arpPredicate,
            AResource arpObject) {

        try {
            tell(translate(arpSubject),
                    translatePredicate(arpPredicate), translate(arpObject));
        } catch (Exception ez) {
            System.err.println(ez);
        }

    }

    public void statement(AResource arpSubject, AResource arpPredicate,
            ALiteral arpLiteral) {

        try {
            tell(translate(arpSubject),
                    translatePredicate(arpPredicate),
                    translate(arpLiteral));
        } catch (Exception ez) {
            System.err.println(ez);
        }

    }
*/


public static void printBytes(byte[] array, String name) {
    for (int k = 0; k < array.length; k++) {
        System.out.println(name + "[" + k + "] = " + "0x" +
                           byteToHex(array[k]));
    }
}



  static public String byteToHex(byte b) {
      // Returns hex String representation of byte b
      char hexDigit[] = {
         '0', '1', '2', '3', '4', '5', '6', '7',
         '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'
      };
      char[] array = { hexDigit[(b >> 4) & 0x0f], hexDigit[b & 0x0f]
};
      return new String(array);
   }


   static public String charToHex(char c) {
      // Returns hex String representation of char c
      byte hi = (byte) (c >>> 8);
      byte lo = (byte) (c & 0xff);
      return byteToHex(hi) + byteToHex(lo);
   }


}
