package org.ilrt.inkling.query;

import java.sql.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
<pre>
An implementation of java.sql.ResultSetMetaData
</pre>
 */

public class ResultSetMetaData implements java.sql.ResultSetMetaData {
    //don't know what these should be
    public final static int columnNoNulls = 0;
    public final static int columnNullable = 0;
    public final static int columnNullableUnknown = 0;
    org.ilrt.inkling.query.ResultSet resultset = null;

    public ResultSetMetaData(org.ilrt.inkling.query.ResultSet r) {
        this.resultset = r;
    }

    public int getColumnCount() throws SQLException {
        if (resultset != null) {
            return resultset.getColumnNames().size();
        } else {
            return 0;
        }
    }

    /** assume better to create another one - so always returns true */
    public boolean isAutoIncrement(int column) throws SQLException {
        return true;
    }

    /** case matters for RDF */
    public boolean isCaseSensitive(int column) throws SQLException {
        return true;
    }

    /**
      *Can the column be used in a where clause?
      *assume not
      */
    public boolean isSearchable(int column) throws SQLException {
        return false;
    }

    /**
      *Is the column a signed number?
      *assume not
      */
    public boolean isSigned(int column) throws SQLException {
        return false;
    }

    /** assume varchar length */
    public int getColumnDisplaySize(int column) throws SQLException {
        return 256;
    }

    public String getColumnLabel(int column) throws SQLException {

//        System.out.println("RSMD "+resultset.colnames.size()+" "+column);
        if (resultset != null) {
            return (String) resultset.colnames.elementAt(column);
        } else {
            return "";
        }
    }

    public String getColumnName(int column) throws SQLException {
        return getColumnLabel(column);
    }

    public String getSchemaName(int column) throws SQLException {
        return "";
    }

    public int getPrecision(int column) throws SQLException {
        return 0;
    }

    public int getScale(int column) throws SQLException {
        return 0;
    }

    public String getTableName(int column) throws SQLException {
        return "triples";
    }

    public String getCatalogName(int column) throws SQLException {
        return "";
    }

    public int getColumnType(int column) throws SQLException {
        return 0;
    }

    public String getColumnTypeName(int column) throws SQLException {
        return "String";
    }

    public boolean isReadOnly(int column) throws SQLException {
        return true;
    }

    public boolean isWritable(int column) throws SQLException {
        return false;
    }

    public boolean isDefinitelyWritable(int column) throws SQLException {
        return false;
    }

    public boolean isCurrency(int column) {
        return false;
    }

    public String getColumnClassName(int column) {
        return "";
    }

    public int isNullable(int column) {
        return 0;
    }
}

