package org.ilrt.inkling.query;

import org.ilrt.inkling.api.*;
import java.util.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
<pre>
Used in QE.java for building a resultset with no duplicates
</pre>
*/

public class TreeNode extends Node {

    public Vector kids;

//    private String text = null;//now content (from Node)

    private String var = null;

    public int level=10;//default
    private int type = 0;

    TreeNode parent = null;

    public TreeNode() {
        kids = new Vector();
    }


    public TreeNode(String content) {
        this.setContent(content.trim());
        kids = new Vector();
    }

/**

special constructor  for converting Nodes to TreenOdes

*/
    public TreeNode(Node node) {

//must be a better way....
	this.setContent(node.getContent());
	this.isresource=node.isresource;
	this.isbnode=node.isbnode;
	this.setID(node.getID());
	this.setGraph(node.getGraph());

        kids = new Vector();
    }

    public void setType(int i) {
        type = i;
    }

    public int getType() {
        return type;
    }

    public String getVar() {
        return var;
    }

    public void setVar(String var) {
        this.var = var.trim();
    }

    public void add(TreeNode node) {
        kids.addElement(node);
        node.setParent(this);
    }


    public Vector getLinks() {
        return kids;
    }


    public String dumpall() {
        return (this.toString() + ", "+this.getContent());
    }

    public TreeNode getParent() {
        return this.parent;
    }

    public void setParent(TreeNode parent) {
        this.parent = parent;
    }


///level is made up

    public String toString(){
	return spew(level, new String());
    }


/**

printing for debugging

*/

    public String spew(int level, String s) {

        s=s+"\n"+level + " "+this.getContent() + " var "+
                this.getVar() + ":";
        level++;
        if (kids.size() == 0) {
            s=s+"no kids\n\n";
            level--;
        } else {
            Enumeration e = kids.elements();
            while (e.hasMoreElements()) {
                TreeNode t = (TreeNode) e.nextElement();

                for (int i = 0; i < level; i++) {
                    s=s+" ";
                }

                s=s+t.getContent();
                s=s+t.spew(level, s);
            }
        }

    return s;

    }

/**

Overridden equals method

*/

    public boolean equals(Object obj) {
        if (obj instanceof TreeNode) {
            if (this.getContent().equals(((TreeNode) obj).getContent()))
                return true;
        }
        return false;
    }




/**

Check that the current treenode doesn't contain a piece of content

*/

    public boolean hasTextRecursive(String text) {

        //assume at the bottom
        if (text.equals(this.getContent())) {
            return true;
        } else {
            TreeNode parent = this.getParent();

            if (parent != null) {
                return parent.hasTextRecursive(text);
            } else {
                return false;
            }

        }

    }
/**

Check that the current treenode doesn't contain a piece of content and a
particular variable name

*/

    public int hasTextVarRecursive(String text, String var, boolean isresource) {

	text=text.trim();
	var=var.trim();
	
        //0=match; 1=no match; 2=var match

        //assume at the bottom
        if (this.getContent() != null && this.var != null) {

            if (text.equals(this.getContent()) && 
var.equals(this.var)&& this.isresource==isresource) {
                //we alreday have this combination
                return 1;
            } else {
                if (!text.equals(this.getContent()) && var.equals(this.var)) {
                    //we have a similar combination already
                    return 2;
                } else {
                    //we don't have this combination; try up the tree
                    TreeNode parent = this.getParent();

                    if (parent != null) {
                        return parent.hasTextVarRecursive(text, var,isresource);
                    } else {
                        return 1;
                    }

                }
            }

        } else {
            return 1;
        }

    }


/**

printing method for debugging

*/
    public void dumpKids() {

        Enumeration e = kids.elements();
        while (e.hasMoreElements()) {
            System.out.println(((TreeNode) e.nextElement()).dumpall());
        }

    }

}
