package org.ilrt.inkling.test;

import junit.framework.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/


/**
<pre>
Runs all SQL-related tests.
</pre>
*/

public class AllSQLTests {
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }


    public static Test suite() {

        TestSuite suite = new TestSuite();

	suite.addTest(new BaseTestSQLGraph("testBase"));
	suite.addTest(new Squish2SQLTest("testConvert"));
	suite.addTest(new SQLGraphTest("testQuery"));
	suite.addTest(new MySQLGraphTest("testQuery"));
	suite.addTest(new SQLCheckSize("testCheckSize"));
        suite.addTest(new QueryI18NTestMySQL("testQuery"));
        suite.addTest(new QueryI18NTestPostgres("testQuery"));

//currently not working
//        suite.addTest(new SQLGraphTestProv("testQuery"));


        return suite;
    }
}


