package org.ilrt.inkling.test;

import org.ilrt.inkling.api.*;
import java.util.*;
import junit.framework.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/


/**

<pre>
An SQL query, ensuring 'base' is returned ok.
</pre>
*/

public class BaseTestSQLGraph extends TestCase {

    public BaseTestSQLGraph(String name) {
        super(name);
    }


    public static Test suite() {
        return new TestSuite(BaseTestSQLGraph.class);
    }


    public static void main(String args[]) {
        junit.textui.TestRunner.run(suite());
    }


/**

A test of getting base from Union and SQL Graphs

*/

    public void testBase(){

String mbox="mailto:libby.miller@bristol.ac.uk";
String sha1mbox=Util.sha1(mbox);

String
uri="http://swordfish.rdfweb.org/photos/genfiles/ilrt/5018518518518519.rdf";

        Graph gr = new Graph(null, uri, Util.RDFXML);
	gr.load();

	String base=gr.getBase();
	assertEquals(uri,base);

	UnionGraph ug=new UnionGraph(); 
	ug.add(gr);	

System.out.println("UG base "+ug.getBase());

	Hashtable h = ug.getGraphs();
	Enumeration e = h.keys();
	while(e.hasMoreElements()){
	String key = (String)e.nextElement();
	Graph gg = (Graph)h.get(key);
	
System.out.println("UG subgraph base "+gg.getBase()+" key "+key);
	assertEquals(uri,gg.getBase());

	}


        SQLGraph sq = new SQLGraph();     
	String db="jdbc:mysql://127.0.0.1:3306/test?user=mysql";

        sq.setdb(db);
        sq.setDriver("com.mysql.jdbc.Driver");
	sq.removeAll();
        sq.add(gr);

System.out.println("SQL base "+sq.getBase());

	Hashtable hh = sq.getGraphs();
	Enumeration ee=hh.keys();

	while(ee.hasMoreElements()){
	String key = (String)ee.nextElement();
	
System.out.println("SQL subgraph base "+key);
	assertEquals(uri,key);

	}



}//end testmethod


}//end class
