package org.ilrt.inkling.test;

import org.ilrt.inkling.api.*;
import java.util.*;
import junit.framework.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/


/**

<pre>
Tests base working for Graph and UnionGraph.
</pre>
*/

public class BaseTestUnionGraph extends TestCase {

    public BaseTestUnionGraph(String name) {
        super(name);
    }


    public static Test suite() {
        return new TestSuite(BaseTestUnionGraph.class);
    }


    public static void main(String args[]) {
        junit.textui.TestRunner.run(suite());
    }


/**

A test of getting the base back

*/

    public void testBase(){

String
uri="http://swordfish.rdfweb.org/photos/genfiles/ilrt/005276920438957476.rdf";

        Graph gr = new Graph(null, uri, Util.RDFXML);
	gr.load();
	String base=gr.getBase();

//System.out.println("in mem base "+base);
assertEquals(base,uri);

	UnionGraph ug=new UnionGraph(); 
	ug.add(gr);	


System.out.println("UG base "+ug.getBase());

	Hashtable h = ug.getGraphs();
	Enumeration e = h.keys();
	while(e.hasMoreElements()){
	String key = (String)e.nextElement();
	Graph gg = (Graph)h.get(key);
	
System.out.println("UG subgraph base "+gg.getBase()+" key "+key);

assertEquals(base,gg.getBase());

	}



}//end testmethod


}//end class
