package org.ilrt.inkling.test;

import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;
import org.ilrt.inkling.api.*;
import java.util.*;
import junit.framework.*;


/**

Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231

*/

/**
<pre>
Checking two different methods of querying inmemory graphs
</pre>

*/


public class GraphTest extends TestCase {

    public GraphTest(String name) {
        super(name);
    }


    public static Test suite() {
        return new TestSuite(GraphTest.class);
    }


    public static void main(String args[]) {
        junit.textui.TestRunner.run(suite());
    }



    public void testQuery(){

String mbox="mailto:libby.miller@bristol.ac.uk";
String sha1mbox=Util.sha1(mbox);

String
uri="http://swordfish.rdfweb.org/photos/genfiles/ilrt/5018518518518519.rdf";

String query= "SELECT ?pic, ?thumb, ?x  "+
//" from "+uri+" "+
" WHERE "+
   "(foaf:depicts ?pic ?x) "+
//   "(foaf:mbox_sha1sum ?x ?mb) "+
   "(foaf:mbox_sha1sum ?x '"+sha1mbox+"') "+
   "(foaf:thumbnail ?pic ?thumb) "+
" USING foaf for http://xmlns.com/foaf/0.1/ "+
" dc for http://purl.org/dc/elements/1.1/ ";



int count=0;
int count1=0;

java.sql.ResultSet r1 =null;
java.sql.ResultSet r2 =null;

        Graph gr = new Graph(null, uri, Util.RDFXML);

	ComplexQuery cq=(ComplexQuery)SquishParser.parse(query);
	cq.getGraphs().addElement(gr);
	QE qe=new QE();

	try{
	r1=qe.executeQuery(cq);

		while (r1.next()) { 
		count++;
		}//end while

	}catch(Exception e){
	System.err.println("GraphTest error "+e);
	e.printStackTrace();
	}

	try{
	r2=gr.askSquish(query);

		while (r2.next()) { 
        System.out.println("pic "+(String)r2.getString("pic"));
        System.out.println("thumb "+(String)r2.getString("thumb"));

		count1++;
		}//end while

	}catch(Exception e){
	System.err.println("GraphTest error "+e);
	e.printStackTrace();
	}


System.out.println("count "+count);
System.out.println("count1 "+count1);
assertEquals(1,count);

}//end testmethod



}//end class
