package org.ilrt.inkling.test;

import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;
import org.ilrt.inkling.api.*;
import java.util.*;
import junit.framework.*;


/*

Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231

*/

/**
<pre>
checking that two parsers (ARP and Rio) give the same size graphs
</pre>
*/

public class ParsersTest extends TestCase {

    public ParsersTest(String name) {
        super(name);
    }


    public static Test suite() {
        return new TestSuite(ParsersTest.class);
    }


    public static void main(String args[]) {
        junit.textui.TestRunner.run(suite());
    }


    public void testQuery(){

java.sql.ResultSet r1 =null;
java.sql.ResultSet r2 =null;
String mbox="mailto:libby.miller@bristol.ac.uk";
String sha1mbox=Util.sha1(mbox);

String
uri="http://swordfish.rdfweb.org/photos/genfiles/ilrt/5018518518518519.rdf";

String query= "SELECT ?pic, ?thumb, ?x  "+
" WHERE "+
   "(foaf:depicts ?pic ?x) "+
   "(foaf:mbox_sha1sum ?x '"+sha1mbox+"') "+
   "(foaf:thumbnail ?pic ?thumb) "+
" USING foaf for http://xmlns.com/foaf/0.1/ "+
" dc for http://purl.org/dc/elements/1.1/ ";

int count=0;
int count2=0;


        Graph gr = new Graph(null, uri, Util.RDFXML);

        Graph gr2 = new Graph(null, uri, Util.TEST);

	count=gr.getSize();
	count2=gr2.getSize();

	System.out.println("checking both graphs empty");
	System.out.println("count "+count);
	System.out.println("count2 "+count2);
	assertEquals(0,count);
	assertEquals(0,count2);

	gr.load();
	gr2.load();


	count=gr.getSize();
	count2=gr2.getSize();

	System.out.println("checking both parsers produce the same size graphs");
	System.out.println("count "+count);
	System.out.println("count2 "+count2);

	assertEquals(count,count2);

}//end testmethod



}//end class
