package org.ilrt.inkling.test;

import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;
import org.ilrt.inkling.api.*;
import java.util.*;
import junit.framework.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/


/**
<pre>
Testing insertion and query of SQL graphs with Postgres
</pre>
*/

public class PostgresqlTest extends TestCase {

    public PostgresqlTest(String name) {
        super(name);
    }


    public static Test suite() {
        return new TestSuite(PostgresqlTest.class);
    }


    public static void main(String args[]) {
        junit.textui.TestRunner.run(suite());
    }



    public void testQuery(){

java.sql.ResultSet r1 =null;
String mbox="mailto:libby.miller@bristol.ac.uk";
String sha1mbox=Util.sha1(mbox);

String
uri="http://swordfish.rdfweb.org/photos/genfiles/ilrt/5018518518518519.rdf";

String query= "SELECT ?pic, ?thumb, ?x  "+
" WHERE "+
   "(foaf:depicts ?pic ?x) "+
   "(foaf:mbox_sha1sum ?x '"+sha1mbox+"') "+
   "(foaf:thumbnail ?pic ?thumb) "+
" USING foaf for http://xmlns.com/foaf/0.1/ "+
" dc for http://purl.org/dc/elements/1.1/ ";

String
db="jdbc:postgresql://localhost:5432/test?auth=password&user=postgres&password=notneeded";

        SQLGraph sq = new SQLGraph();
        sq.setdb(db);
        sq.setDriver("org.postgresql.Driver");
	sq.removeAll();


int count=0;

        Graph gr = new Graph(null, uri, Util.RDFXML);
        gr.load();

	sq.add(gr);

	try{

	r1=sq.askSquish(query);

		while (r1.next()) { 
		count++;
		String pic=(String)r1.getString("pic");
		String thumb=(String)r1.getString("thumb");
//		String mb=(String)r1.getString("x");
		System.out.println("pic "+pic+" "+thumb);
//		System.out.println("pic "+pic+" "+mb);
		}//end while

	}catch(Exception e){
	System.err.println("MySQL GraphTest error "+e);
	e.printStackTrace();
	}

System.out.println("count "+count);
assertEquals(1,count);

}//end testmethod


}//end class
