package org.ilrt.inkling.test;

import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;
import org.ilrt.inkling.api.*;
import java.util.*;
import java.io.*;
import junit.framework.*;

/*

Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231

*/
/**
<pre>
Tests internationalization with Postgres, saving to
i18ntestpostgres.html
</pre>
*/

public class QueryI18NTestPostgres extends TestCase {

    public QueryI18NTestPostgres(String name) {
        super(name);
    }


    public static Test suite() {
        return new TestSuite(QueryI18NTestPostgres.class);
    }


    public static void main(String args[]) {
        junit.textui.TestRunner.run(suite());
    }


    public void testQuery(){

java.sql.ResultSet r1 =null;
java.sql.ResultSet r2 =null;

String mbox="mailto:libby.miller@bristol.ac.uk";
String sha1mbox=Util.sha1(mbox);

String 

//uri="http://www.w3.org/People/Charles/foaf.rdf";

//uri="file:shigerufoaf.rdf";

//uri="http://www.shigeru.ath.cx/MT/F1/index.rdf";
//uri="http://anoh.s10.xrea.com/foaf.rdf";


//uri="http://web.sfc.keio.ac.jp/~t00274yw/diary/foaf.rdf";
//uri="http://antipop.zapto.org/foaf.rdf";
//uri="http://www.remus.dti.ne.jp/~a-satomi/profiles/foaf/foaf.rdf";

uri="http://www.kanzaki.com/info/webwho.rdf";

//uri="http://swordfish.rdfweb.org/photos/genfiles/ilrt/005276920438957476.rdf";

String query= "SELECT ?name "+
" WHERE "+
   "(foaf:name ?x ?name) "+
" USING foaf for http://xmlns.com/foaf/0.1/ "+
" dc for http://purl.org/dc/elements/1.1/ ";

String
db="jdbc:postgresql://localhost:5432/test?auth=password&user=postgres&password=notneeded";

        SQLGraph sq = new SQLGraph();
        sq.setdb(db);
	sq.setDriver("org.postgresql.Driver");
	sq.removeAll();
        Graph gr = new Graph(null, uri, Util.RDFXML);
        gr.load();
        sq.add(gr);


int count=0;

	StringBuffer sb = new StringBuffer();
	StringBuffer sb2 = new StringBuffer();

	try{

		r1=sq.askSquish(query);
		r2=gr.askSquish(query);


		while (r1.next()) { 
		count++;
		String n=(String)r1.getString("name");
//		System.out.println("1 "+n);
		sb.append(n);
		}//end while
		while (r2.next()) { 
		count++;
		String n=(String)r2.getString("name");
//		System.out.println("1 "+n);
		sb2.append(n);
		}//end while

	}catch(Exception e){
	System.err.println("ParsersTest2 error "+e);
	e.printStackTrace();
	}


System.out.println("count "+count);

Util.save("i18ntestpostgres.html","","<html><head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"></head><body>\n"+sb.toString()+"\n<hr />"+sb2.toString()+"</body></html>");



}//end testmethod


}//end class
