package org.ilrt.inkling.test;

import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;
import org.ilrt.inkling.api.*;
import java.util.*;
import junit.framework.*;


/*

Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231

*/


/**
<pre>
Checking an inmemory and SQL graph gives the same number of nodes.
@@test more extensively - are the uniqueness conditions now different
for SQL and in-memory versions?@@
</pre>
*/

public class SQLCheckSize extends TestCase {

    public SQLCheckSize(String name) {
        super(name);
    }


    public static Test suite() {
        return new TestSuite(SQLCheckSize.class);
    }


    public static void main(String args[]) {
        junit.textui.TestRunner.run(suite());
    }


    public void testCheckSize(){

java.sql.ResultSet r1 =null;
java.sql.ResultSet r2 =null;

String
uri="http://swordfish.rdfweb.org/photos/genfiles/ilrt/5018518518518519.rdf";

String query= "SELECT ?s, ?p, ?o where (?p ?s ?o)";

int count=0;
int count2=0;


        Graph gr = new Graph(null, uri, Util.RDFXML);
	gr.load();
	count=gr.getSize();

	SQLGraph sq = new SQLGraph();
	String db="jdbc:mysql://127.0.0.1:3306/test?user=mysql";
        sq.setdb(db);
        sq.setDriver("com.mysql.jdbc.Driver");
	sq.removeAll();
	sq.add(gr);

	count2=sq.getSize();

	System.out.println("checking both graphs are the same size");

	System.out.println("count "+count);
	System.out.println("count2 "+count2);

	assertEquals(count,count2);

}//end testmethod



}//end class
