package org.ilrt.inkling.test;

import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;
import org.ilrt.inkling.api.*;
import java.util.*;
import junit.framework.*;

/*

Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231

*/

/**
<pre>
Testing SQL queries and using ResultSets with getNode()
</pre>
*/


public class SQLGraphTest extends TestCase {

    public SQLGraphTest(String name) {
        super(name);
    }


    public static Test suite() {
        return new TestSuite(SQLGraphTest.class);
    }


    public static void main(String args[]) {
        junit.textui.TestRunner.run(suite());
    }


    public void testQuery(){

java.sql.ResultSet r1 =null;
String mbox="mailto:libby.miller@bristol.ac.uk";
String sha1mbox=Util.sha1(mbox);

String
uri="http://swordfish.rdfweb.org/photos/genfiles/ilrt/5018518518518519.rdf";

String query= "SELECT ?pic, ?thumb, ?x  "+
" WHERE "+
   "(foaf:depicts ?pic ?x) "+
   "(foaf:mbox_sha1sum ?x '"+sha1mbox+"') "+
   "(foaf:thumbnail ?pic ?thumb) "+
" USING foaf for http://xmlns.com/foaf/0.1/ "+
" dc for http://purl.org/dc/elements/1.1/ ";

String query2= "SELECT ?mb  "+
" WHERE "+
   "(foaf:mbox_sha1sum ?x ?mb) "+
" USING foaf for http://xmlns.com/foaf/0.1/ ";


String 
db="jdbc:mysql://127.0.0.1:3306/test?user=mysql";


int count=0;

	SQLGraph sq = new SQLGraph();
        sq.setdb(db);
	sq.setDriver("com.mysql.jdbc.Driver");
	sq.removeAll();
        Graph gr = new Graph(null, uri, Util.RDFXML);
        gr.load();
	sq.add(gr);

	try{

	r1=sq.askSquish(query);

	org.ilrt.inkling.query.ResultSet r2=(org.ilrt.inkling.query.ResultSet)r1;
	r2.setSQLProv(false);
		while (r2.next()) { 
		count++;
		Node pic=(Node)r2.getNode("pic");
		String id = pic.getGraph().getID();//nothing yet

		System.out.println("pic "+pic.getContent());
		System.out.println("id "+id);
//		System.out.println("thumb "+thumb);
//		System.out.println("id "+thumbid);
		}//end while

	}catch(Exception e){
	System.err.println("GraphTest error "+e);
	e.printStackTrace();
	}

System.out.println("count "+count);
assertEquals(1,count);

//testing how literals look
count=0;

	try{
	org.ilrt.inkling.query.ResultSet
r3=(org.ilrt.inkling.query.ResultSet)sq.askSquish(query2);
		while (r3.next()) { 
		count++;
		SQLNode mb=(SQLNode)r3.getNode("mb");
		String id = mb.getGraph().getID();//nothing yet

		System.out.println("mb "+mb);
//		System.out.println("id "+id);
		}


	}catch(Exception e){
	System.err.println("GraphTest error "+e);
	e.printStackTrace();
	}

System.out.println(count);
assertEquals(4,count);

//other tests

//Vector test1=sq.ask(null,"http://xmlns.com/foaf/0.1/name", null);

//System.out.println(test1);

//test1 will be empty at the moment

}//end testmethod


}//end class
