package org.ilrt.inkling.test;

import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;
import org.ilrt.inkling.api.*;
import java.util.*;
import junit.framework.*;

/*

Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
<pre>
Increasing complexity of queries.
</pre>
*/

public class SQLStressTest extends TestCase {

    public SQLStressTest(String name) {
        super(name);
    }


    public static Test suite() {
        return new TestSuite(SQLStressTest.class);
    }


    public static void main(String args[]) {
        junit.textui.TestRunner.run(suite());
    }


    public void testQuery(){

	java.sql.ResultSet r1 =null;

        String query="SELECT ?img "+
            "WHERE "+
            "   (rdf:type ?img foaf:Image) "+
            "USING foaf for http://xmlns.com/foaf/0.1/ "+
            " rdf for http://www.w3.org/1999/02/22-rdf-syntax-ns#";



        String query2="SELECT ?img, ?x, ?z "+
            "WHERE "+
            "   (rdf:type ?img foaf:Image) "+
            "   (foaf::depiction ?x ?img) "+
            "   (foaf::depiction ?z ?img) "+
            "USING foaf for http://xmlns.com/foaf/0.1/ "+
            " rdf for http://www.w3.org/1999/02/22-rdf-syntax-ns#";


        String query3="SELECT ?mbox1, ?mbox2 "+
            "WHERE "+
//testing if any better
            "   (rdf:type ?img foaf:Image) "+
            "   (foaf::depiction ?x ?img) "+
            "   (foaf::depiction ?z ?img) "+
            "   (foaf::mbox_sha1sum ?x ?mbox1) "+
            "   (foaf::mbox_sha1sum ?z ?mbox2) "+
            "USING foaf for http://xmlns.com/foaf/0.1/ "+
            " rdf for http://www.w3.org/1999/02/22-rdf-syntax-ns#";


        String query4="SELECT ?mbox1, ?mbox2, ?name1, ?name2 "+
            "WHERE "+
//testing if any better
            "   (rdf:type ?img foaf:Image) "+
            "   (foaf::depiction ?x ?img) "+
            "   (foaf::depiction ?z ?img) "+
            "   (foaf::mbox_sha1sum ?x ?mbox1) "+
            "   (foaf::mbox_sha1sum ?z ?mbox2) "+
            "   (foaf::thumbnail ?img ?uri) "+
            "   (foaf::name ?x ?name1) "+
            "   (foaf::name ?z ?name2) "+
            "USING foaf for http://xmlns.com/foaf/0.1/ "+
            " rdf for http://www.w3.org/1999/02/22-rdf-syntax-ns#";


String 
db="jdbc:mysql://127.0.0.1:3306/test?user=mysql";

String
uri="http://swordfish.rdfweb.org/photos/genfiles/ilrt/005276920438957476.rdf";

	SQLGraph sq = new SQLGraph();
	sq.removeAll();
        sq.setdb(db);
	sq.setDriver("com.mysql.jdbc.Driver");

	Graph gr = new Graph(null, uri,Util.RDFXML);

int count=0;
	try{
	r1=sq.askSquish(query);
		while (r1.next()) { 
		count++;
		}//end while
	System.out.println("count "+count);
	count=0;

	java.sql.ResultSet r2=sq.askSquish(query2);
		while (r2.next()) { 
		count++;
		}//end while

	System.out.println("count2 "+count);


	count=0;

	java.sql.ResultSet r3=sq.askSquish(query3);
		while (r3.next()) { 
		count++;
		}//end while

	System.out.println("count3 "+count);


	count=0;

	java.sql.ResultSet r4=sq.askSquish(query4);
		while (r4.next()) { 
		count++;
		}//end while

	System.out.println("count4 "+count);

	}catch(Exception e){
	System.err.println("SQLStressTest error "+e);
	e.printStackTrace();
	}

}//end testmethod


}//end class
