package org.ilrt.inkling.test;

import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;
import org.ilrt.inkling.api.*;
import java.util.*;
import junit.framework.*;

/*
Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
<pre>
Converting squish to an SQL query. Does a test based on number of
records returned.
</pre>
*/

public class Squish2SQLTest extends TestCase {

    public Squish2SQLTest(String name) {
        super(name);
    }


    public static Test suite() {
        return new TestSuite(Squish2SQLTest.class);
    }


    public static void main(String args[]) {
        junit.textui.TestRunner.run(suite());
    }



    public void testConvert(){

java.sql.ResultSet r1 =null;
java.sql.ResultSet r2 =null;
String mbox="mailto:libby.miller@bristol.ac.uk";
String sha1mbox=Util.sha1(mbox);


String query= "SELECT ?pic, ?thumb, ?x  "+
" WHERE "+
   "(foaf:depicts ?pic ?x) "+
   "(foaf:mbox_sha1sum ?x '"+sha1mbox+"') "+
   "(foaf:thumbnail ?pic ?thumb) "+
" USING foaf for http://xmlns.com/foaf/0.1/ "+
" dc for http://purl.org/dc/elements/1.1/ ";

int count=0;
int count2=0;

String sql_query = Squish2SQL.convert(query);

System.out.println("squish2sql : "+sql_query);


String db="jdbc:mysql://127.0.0.1:3306/test?user=mysql";
String
uri="http://swordfish.rdfweb.org/photos/genfiles/ilrt/5018518518518519.rdf";    

        Graph gr = new Graph(null, uri, Util.RDFXML);
        gr.load();
        SQLGraph sq = new SQLGraph();
        sq.setDriver("com.mysql.jdbc.Driver");
        sq.setdb(db);
        sq.removeAll();
        sq.add(gr);
        try{
        r1=sq.askSquish(query);
        r2=sq.doSQLQueryClean(sql_query);
                while (r1.next()) {
                count++;
		}
                while (r2.next()) {
                count2++;
		}
	}catch(Exception e){
	System.err.println(e);
	}


assertEquals(count,count2);

}//end testmethod



}//end class
