package org.ilrt.inkling.test;

import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;
import org.ilrt.inkling.api.*;
import java.util.*;
import junit.framework.*;


/**

Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
<pre>
Checking that the UnionGraph remembers the bases of subgraphs, via a
squish query and getNode()
</pre>
*/

public class UnionGraphQueryProvenanceTest extends TestCase {

    public UnionGraphQueryProvenanceTest(String name) {
        super(name);
    }


    public static Test suite() {
        return new TestSuite(UnionGraphQueryProvenanceTest.class);
    }


    public static void main(String args[]) {
        junit.textui.TestRunner.run(suite());
    }


/**

checking query works on union graph

*/

    public void testQuery(){

String mbox="mailto:libby.miller@bristol.ac.uk";
String sha1mbox=Util.sha1(mbox);

String
uri="http://swordfish.rdfweb.org/photos/genfiles/ilrt/5018518518518519.rdf";
String
uri2="http://swordfish.rdfweb.org/photos/genfiles/ilrt/4848036694101509.rdf";

String query= "SELECT ?pic, ?thumb, ?x  "+
" WHERE "+
   "(foaf:depicts ?pic ?x) "+
   "(foaf:mbox_sha1sum ?x '"+sha1mbox+"') "+
   "(foaf:thumbnail ?pic ?thumb) "+
" USING foaf for http://xmlns.com/foaf/0.1/ "+
" dc for http://purl.org/dc/elements/1.1/ ";


int count=0;

java.sql.ResultSet r1 =null;

        Graph gr = new Graph(null, uri, Util.RDFXML);
	gr.load();
        Graph gr2 = new Graph(null, uri2, Util.RDFXML);
	gr2.load();
	UnionGraph ug=new UnionGraph();
	ug.add(gr);
	ug.add(gr2);

	try{
	r1=ug.askSquish(query);

		while (r1.next()) { 
		count++;
//now see if we can work out where this came from...
		org.ilrt.inkling.query.ResultSet
r2=(org.ilrt.inkling.query.ResultSet)r1;

		Node pic=r2.getNode("pic");
		System.out.println("pic "+pic.getContent());

		System.out.println("source "+pic.getGraph().getBase());

		}//end while

	}catch(Exception e){
	System.err.println("GraphTest error "+e);
	e.printStackTrace();
	}


System.out.println("count "+count);
assertEquals(2,count);


}//end testmethod



}//end class
