package org.ilrt.inkling.test;

import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;
import org.ilrt.inkling.api.*;
import org.ilrt.inkling.app.*;
import java.io.*;
import java.net.*;
import java.util.*;
import junit.framework.*;


/*

Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/**
<pre>
Basically want to make sure that a UnionGraph contains exactly the same
statement object as the Graph it contains.
</pre>
*/

public class UnionGraphSameStatementTest extends TestCase {

    public UnionGraphSameStatementTest(String name) {
        super(name);
    }


    public static Test suite() {
        return new TestSuite(UnionGraphSameStatementTest.class);
    }


    public static void main(String args[]) {
        junit.textui.TestRunner.run(suite());
    }


/**

testing that UnionGraph uses the same statement object as the graph

*/

    public void testSameStatement(){

Graph g = new
Graph(null,"http://swordfish.rdfweb.org/people/libby/rdfweb/webwho.xrdf",Util.RDFXML);

g.load();

UnionGraph ug=new UnionGraph();
ug.add(g);

Vector v1=g.ask(null, "http://xmlns.com/foaf/0.1/name", "Libby Miller");
Vector v2=ug.ask(null, "http://xmlns.com/foaf/0.1/name", "Libby Miller");

System.out.println("v1 size "+v1.size());
System.out.println("v2 size "+v2.size());
assertEquals(v1.size(),v2.size());

Statement s1=(Statement)v1.elements().nextElement();
Statement s2=(Statement)v2.elements().nextElement();
assertEquals(s1,s2);

    }


}//end class
