package org.ilrt.inkling.test;

import org.ilrt.inkling.query.*;
import org.ilrt.inkling.query.squish.*;
import org.ilrt.inkling.api.*;
import java.util.*;
import junit.framework.*;


/*

Copyright University of Bristol, 2003

This software is released under the W3C license:
http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
*/

/*
<pre>
Testing that squish queries work over UnionGraphs. Shows two different
ways of querying.
</pre>
*/

public class UnionGraphSquishQueryTest extends TestCase {

    public UnionGraphSquishQueryTest(String name) {
        super(name);
    }


    public static Test suite() {
        return new TestSuite(UnionGraphSquishQueryTest.class);
    }


    public static void main(String args[]) {
        junit.textui.TestRunner.run(suite());
    }


/**

Testing squish queries work with Union graphs

*/

    public void testQuery(){

String mbox="mailto:libby.miller@bristol.ac.uk";
String sha1mbox=Util.sha1(mbox);

String
uri="http://swordfish.rdfweb.org/photos/genfiles/ilrt/5018518518518519.rdf";

String query= "SELECT ?pic, ?thumb, ?x  "+
" WHERE "+
   "(foaf:depicts ?pic ?x) "+
   "(foaf:mbox_sha1sum ?x '"+sha1mbox+"') "+
   "(foaf:thumbnail ?pic ?thumb) "+
" USING foaf for http://xmlns.com/foaf/0.1/ "+
" dc for http://purl.org/dc/elements/1.1/ ";



int count=0;
int count1=0;

java.sql.ResultSet r1 =null;
java.sql.ResultSet r2 =null;

        Graph gr = new Graph(null, uri, Util.RDFXML);
	gr.load();
	UnionGraph ug=new UnionGraph();
	ug.add(gr);

	ComplexQuery cq=(ComplexQuery)SquishParser.parse(query);
	cq.getGraphs().addElement(ug);
	QE qe=new QE();

	try{
	r1=qe.executeQuery(cq);

		while (r1.next()) { 
		count++;
		}//end while

	}catch(Exception e){
	System.err.println("GraphTest error "+e);
	e.printStackTrace();
	}

	try{
	r2=ug.askSquish(query);

		while (r2.next()) { 
		count1++;
		}//end while

	}catch(Exception e){
	System.err.println("GraphTest error "+e);
	e.printStackTrace();
	}


System.out.println("count "+count);
System.out.println("count1 "+count1);
assertEquals(1,count);

}//end testmethod



}//end class
